/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "xcom.h"


__declspec(naked) void KoMCfix()
{
	__asm
	{
		mov    ecx, dword ptr[edi+0Ah]  //edi is current unit's unitpos memory ref
		test   cl, 40h
		jnz    end
		mov    ecx, dword ptr [edi+04]
		mov    al, byte ptr [ecx+0]
		mov    ecx, dword ptr [edi+0Ah]
		and    ecx, 3Fh
		mov    dword ptr [edi+0Ah], ecx
		cmp    al, 3
		jl     xcom
		cmp    al, 0Fh
		jl     alien
		mov    byte ptr [edi+9], 2
		jmp    end
		xcom:
		mov    byte ptr [edi+9], 0
		jmp    end
		alien:
		mov    byte ptr [edi+9], 1
		end:
		ret
	}
}

__declspec(naked) int UnitCountFix()
{
	__asm
	{
	mov     eax, [esi]
	test    al, 2
	jz		skip1
	mov		ecx, dword ptr [esi-6]
	cmp		byte ptr [ecx+0Dh], 0
	jz		skip1
	mov     edx, 417948h
	jmp		edx
	skip1:
	mov		edx, 4179ABh
	jmp		edx
	}
}

void AbortPreEOB()
{
	unsigned char apuppet=0, xpuppy=0;
	unsigned int UnitPOS_0A=0x4A2C4A;
	__asm
		{
		mov     edx, UnitPOS_0A
		mov     esi, 50h
	loop_start:
		movsx   eax, [edx]
		test    al, 2  //active
		jz		loop_end //non active
		test    al, 4  //big or small unit
		jz      valid_unit
		jmp     loop_end
	valid_unit:
		mov     cl, [edx-1]
		cmp     cl, 1     //unit alien?
		jnz     x_unit
		test    al, 40h   
		jz		loop_end  //unit a true alien no MCed aquanaut
		inc     apuppet
		jmp		loop_end
	x_unit:                             
		test    cl, cl
		jnz     loop_end  //unit is civilian
		test    al, 40h
		jnz     x_puppy  //unit is MCed alien
		jmp     loop_end
	x_puppy:
		inc		xpuppy
	loop_end:
		add     edx, 0Eh
		dec     esi
		jnz     loop_start
		}
	if (apuppet>0)
		{
			__asm
			{
				mov     edx, UnitPOS_0A;
				mov     esi, 50h
			loop_start2:
				mov     eax, [edx]
				test    al, 2
				jz      loop_end2
				test    al, 4
				jz      valid_unit2
				test    al, 18h
				jnz     loop_end2
			valid_unit2:
				mov     cl, [edx-1]
				cmp     cl, 1
				jnz     x_unit2
				test    al, 40h
				jz      loop_end2			
				and		eax, 0FFBFh //unit is a MCed soldier, clears the mind control
				mov		[edx],al
				mov		[edx-1],0
				jmp     loop_end2
			x_unit2:                             
				test    cl, cl  
				jnz     loop_end2 // unit is a civilian
				test    al, 40h
				jz		loop_end2   //unit is not MCed alien
			loop_end2:
				add     edx, 0Eh
				dec     esi
				jnz     loop_start2
			}
		}
Tactical_TestForEndOfBattle();
}


void EOB_PreCheck()
{
unsigned char alien=0, apuppet=0, xcom=0, xpuppy=0;
int UnitPOS_0A=0x4A2C4A;
	__asm
		{
		mov     edx, UnitPOS_0A
		mov     esi, 50h
	loop_start:
		mov     eax, [edx]
		test    al, 2  //active unit
		jz      loop_end 	
		test    al, 4  //big or small unit
		jnz     loop_end
		mov     cl, [edx-1]
		cmp     cl, 0     //unit xcom?
		jz		xcom_side
		cmp		cl, 1   //unit alien
		jz		alien_side
		jmp		loop_end
	alien_side:
		test    al, 40h    
		jnz     a_puppet  //unit a mced alien?
		inc     alien
		jmp     loop_end
	a_puppet:
		inc     apuppet
		jmp		loop_end
	xcom_side:                             
		test    al, 40h  //mced alien?
		jnz     x_puppy
		inc     xcom
		jmp     loop_end
	x_puppy:
		inc		xpuppy
		jmp		loop_end
	loop_end:
		add     edx, 0Eh
		dec     esi
		jnz     loop_start
		}
	if (alien==0)
	{
		if (apuppet>0) 
		{
			__asm
			{
				mov     edx, UnitPOS_0A;
				mov     esi, 50h
			loop_start2:
				mov     eax, [edx]
				test    al, 2
				jz		loop_end2
				test    al, 4
				jz      valid_unit2
				test    al, 18h
				jnz     loop_end2
			valid_unit2:
				mov     cl, [edx-1]
				cmp     cl, 1
				jnz     loop_end2
				test    al, 40h
				jz      loop_end2			
				and		eax, 0FFBFh //unit is a MCed soldier, clears the mind control
				mov		[edx],al
				mov		[edx-1],0
		 loop_end2:
				add     edx, 0Eh
				dec     esi
				jnz     loop_start2
			}
		}
	}
Tactical_TestForEndOfBattle();
}


