/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details. 
 * Copyright (C) 2008,2009 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"

typedef struct
{
	char *name;
	unsigned char offset;
}
patch_t;

static patch_t patches[]=
{
	{"damage",22},
	{"resistance",42},
	{"weight",43},
	{"damage type",31},
	{"auto accuracy",32},
	{"snap accuracy",33},
	{"aimed accuracy",34},
	{"auto TUs",35},
	{"snap TUs",36},
	{"aimed TUs",37},
	{"size",38}, //clip size
	{"get",45}, //value for AI to want to pick-up object
};

void *PatchObdata(char *lpFileName)
{
	void *ret=LoadResourceFile(lpFileName);

	if(ret)
	{
		unsigned char *pObData = (unsigned char *)ret;
		for(unsigned char i=0;i<80;i++)
		{
			char keyname[128];
			char *name = (char *)pObData;

			for(int j=0;j<11;j++)
			{
				sprintf(keyname,"%s %s",name,patches[j].name);
				unsigned int val=INI_READ_INT("OBDATA.DAT",keyname,666);
				if(val!=666)
				{
					pObData[patches[j].offset]=(unsigned char)val;
				}
			}

			pObData+=54;
		}
	}

	return ret;
}

void EnableObDataPatching()
{
	//.text:0043A816 E8 55 0C 00 00          call    LoadFile

	InsertCall(0x43A816,PatchObdata);
}
