/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details. 
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"

static short IntroData[]= {
 0x0AC,0x13,
 0x0B6,0x02,
 0x0CC,0x03,
 0x0DD,0x04,
 0x0E1,0x04,
 0x0E5,0x04,
 0x0F9,0x05,
 0x0FC,0x05,
 0x0FE,0x05,
 0x100,0x05,
 0x103,0x05,
 0x105,0x06,
 0x105,0x05,
 0x107,0x05,
 0x10B,0x05,
 0x10D,0x05,
 0x10F,0x07,
 0x10F,0x05,
 0x111,0x05,
 0x115,0x05,
 0x117,0x05,
 0x119,0x08,
 0x118,0x05,
 0x11B,0x05,
 0x11D,0x05,
 0x11F,0x05,
 0x121,0x05,
 0x123,0x09,
 0x123,0x05,
 0x127,0x05,
 0x129,0x05,
 0x12B,0x05,
 0x12D,0x05,
 0x12F,0x05,
 0x131,0x05,
 0x133,0x05,
 0x135,0x05,
 0x179,0x0B,
 0x180,0x0B,
 0x187,0x0B,
 0x18E,0x0C,
 0x1B1,0x0C,
 0x1CE,0x0D,
 0x1D8,0x0D,
 0x1DD,0x0C,
 0x1E7,0x0E,
 0x1ED,0x0F,
 0x216,0x12,
 0x23C,0x13,
 0x23E,0x13,
 0x245,0x14,
 0x266,0x15,
 0x283,0x17,
 0x285,0x17,
 0x287,0x17,
 0x289,0x17,
 0x28B,0x17,
 0x28D,0x17,
 0x28F,0x17,
 0x291,0x17,
 0x293,0x17,
 0x295,0x17,
 0x297,0x17,
 0x299,0x17,
 0x2C6,0x18,
 0x2CB,0x1A,
 0x2CE,0x18,
 0x2CE,0x18,
 0x2D5,0x1B,
 0x2DE,0x1B,
 0x2E5,0x1C,
 0x2EE,0x18,
 0x2FC,0x18,
 0x300,0x18,
 0x30D,0x18,
 0x311,0x18,
 0x314,0x03,
 0x327,0x17,
 0x329,0x17,
 0x32D,0x17,
 0x32F,0x18,
 0x335,0x1C,
 0x338,0x1A,
 0x341,0x1E,
 0x348,0x1E,
 0x34B,0x1E,
 0x36E,0x13,
 0x36F,0x13,
 0x370,0x13,
 0xfff,0xff,
};


static void PlayIntroSound(int frame)
{
	short *ptr=IntroData;
//.data:00479B80 ?? ?? ?? ??                   pSoundList dd ?                         ; DATA XREF: LoadSampleFile+17Fw
	IDirectSoundBuffer **pSoundList=(IDirectSoundBuffer **)0x479B80;


	do
	{
		if(*ptr==frame)
		{
			int sample=*(ptr+1);
			IDirectSoundBuffer *pBuffer=pSoundList[sample];
			IDirectSoundBuffer_SetCurrentPosition(pBuffer,0);
			IDirectSoundBuffer_Play(pBuffer,0,0,0);
		}
		ptr+=2;
	} while(*ptr<=frame);
}

__declspec(naked) int HookPlayIntroSound()
{
	__asm
	{
		pusha
		push eax
		call PlayIntroSound
		add esp,4
		popa
		cmp     eax, 0xB4
		ret
	}
}

void FixIntroSounds()
{
	InsertCall(0x45D4C8,HookPlayIntroSound);
}
