/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "xcom.h"
#include "patches.h"


void clipweightassign() 
{
	char   CurrentUnitIdx=*(char*)0x4783B4; //eu
	short  CurrentSelectedObjIDX=*(short*)0x4783BC; //eu

	for(unsigned char i=0; i<170;i++)
	{
		int UnkObjOBPOSref=0x4A5FE0+(i*16); //eu
		if (*(char *)UnkObjOBPOSref!=0xFF)
			{
			if(*(short *)(UnkObjOBPOSref+6)!=0xFFFF)
				{
				if (*(short *)(UnkObjOBPOSref+6)==CurrentSelectedObjIDX)
					{
					*(char *)(UnkObjOBPOSref+4)=CurrentUnitIdx;
					}
				}
			}
	}
}


void clipweightremove()
{
	short CurrentSelectedObjIDX=*(short*)0x4783BC;
	
	for(unsigned char i=0; i<170;i++)
	{
		int UnknObposref=0x4A5FE0+(i*16);
		
		if (*(char *)UnknObposref!=0xFF) //Is this a valid object?
			{
			if(*(short *)(UnknObposref+6)!=0xFFFF)  //Is this object ammo?
				{
				if (*(short *)(UnknObposref+6)==CurrentSelectedObjIDX)
					{
					*(char *)(UnknObposref+4)=0xFF;
					}
				}
			}
	}
}

__declspec(naked) void ClipFixHook1()  //4199F7
{
	__asm
	{
	mov     dl, byte ptr ds:4783B4h //EU
	mov		byte ptr [esi+4], dl
	call	clipweightassign
	mov     word ptr ds:4783CAh, 1  //EU
	ret
	}
}

__declspec(naked) void ClipFixHook2()  //419886
{
    __asm
	{
	mov     byte ptr [esi+4], 0FFh
	call	clipweightremove
	mov     al, byte ptr ds:4781C8h //tactical playing side  EU
	ret
	}
}

__declspec(naked) void ClipFixHook3()  //419A0B
{
    __asm
	{
	mov     byte ptr [esi+4], 0FFh
	call    clipweightremove
	mov     word ptr ds:4783CAh, 1
	ret
	}
}


__declspec(naked) void ClipFixPanic() //Panic drop 41FC41  EU
{
    __asm
	{
		xor		ecx, ecx
		xor		eax, eax
		xor		edx, edx
		mov		ecx, esi
		sub		ecx, 4A5FE4h 
		shl		ecx, 4  //ecx is now weapon OBPOSidx
		mov		edx, 4A5FE0h
		loopstart:
		cmp		word ptr [edx+6], cx
		jz		found
		add		edx, 10h          //searches entire OBPOS.DAT to find the clip which container is the same ID as the weapon
		inc		eax					//or gets to end of records
		cmp		eax, 0AAh
		jz		end
		jmp		loopstart
		found:
		mov		[edx+4], 0FFh
		end: 
		xor		ecx,ecx
		xor		edx,edx
		mov		cl, byte ptr ds:4781E0h
		mov		dl, byte ptr ds:4781E2h
		mov		eax, 41FC30h
		jmp		eax
	}
}

__declspec(naked) void ClipFixHook5()  //throw 40F56C  EU
{
	__asm
	{
		mov     byte ptr [ecx+4], 0FFh
		call	clipweightremove
		mov     ax, word ptr ds:49DB14h
		mov		edx, 40F576h
		jmp		edx
	}
}

__declspec(naked) void ItemDest()
{
	__asm
	{
		mov		ax, word ptr ds:4783EAh //weapon damage type
		cmp		ax, 2
		jnz		direct
		cmp		byte ptr [esi-4], 22h
		jz      clip
		cmp     byte ptr [esi-4], 24h
		jz      clip
		cmp     byte ptr [esi-4], 26h
		jz      clip
		cmp     byte ptr [esi-4], 28h
		jz      clip
		cmp     byte ptr [esi-4], 2Ah
		jz      clip
		mov		byte ptr [esi-4], 0FFh
		mov		eax, 40E669h
		jmp		eax
	clip: 
			mov		ecx, esi
			sub		ecx, 4A5FE4h
			shl		ecx, 4
			mov		edx, 4A5FE0h
			xor		eax, eax
		cliploop:
			cmp     word ptr [edx+6], cx
			jz      found
			add     edx, 10h
			inc     eax
			cmp     eax, 0AAh
			jz      skip
			jmp     cliploop
		found:
			mov     byte ptr [edx], 0FFh
	skip:
		mov		byte ptr [esi-4], 0FFh
		mov		eax, 40E669h
		jmp		eax
	direct:
		mov		al, byte ptr [esi-4]
		cmp		al, 22h
		jz		weapon
		cmp		al, 24h
		jz		weapon
		cmp		al, 26h
		jz		weapon
		cmp		al, 28h
		jz		weapon
		cmp		al, 2Ah
		jnz		saved
	weapon:
		push	64
		call	GetRandomNum
		add		esp, 4
		mov		cx, word ptr ds:49B85Eh //game difficulty
		shl		cx, 2  //multiply by 4
		add     al, cl
		xor		ecx, ecx
		cmp		al, 14h
		jl		saved
		jmp     clip
	saved:
		xor		ecx, ecx
		xor		eax, eax
		mov     byte ptr [esi], 0FFh
		mov     al, [edi]
		mov     [esi-3], al
		mov		edx, 40E63Fh
		jmp		edx
	}
}

__declspec(naked) void BurnItems()
{
	__asm
	{
		mov     al, byte ptr [esi+edx*2+2Ah]
		and     al, 0FFh
		xor     edx, edx
		mov     dl, 3Ch
		sub     edx, eax
		mov		esi, edx
		movsx   edx, byte ptr [ebp-3]
		shl     edx, 2
		add     edx, 2
		push    edx
		call    GetRandomNum
		add     esp, 4
		cmp     esi, eax
		jg      skip
		mov     byte ptr [ecx-2], 0FFh
		skip:
		mov     eax, 42A006h
		jmp     eax
	}
}

__declspec(naked) void ZombieItemFix()
{
	__asm
	{
		mov		byte ptr ds:477EB4h, 1  //Is UPS Explosion. No deathanimations
		push    edx
		call    Tactical_KillUnit
		push    3Ch
		call    Sleep_time
		push	0A0h
		push    3Fh
		push    24h //25h
		call    SoundCall
		mov     dx, word ptr ds:4783ECh  //VictimUnitPOS id.
		push    1
		push    edx
		call    MorphUnit
		xor		eax, eax
		mov		ax, word ptr ds:4783ECh
		imul    eax, 0Eh
		add     eax, 4A2C40h
		mov     al, byte ptr [eax+9]
		cmp     al, 2
		jnz     skip
		inc		word ptr ds:478454h  //increase the number of civilian death by aliens one more.
	skip:
		mov		byte ptr ds:477EB4h, 0
		mov     eax, 40678Fh
		jmp		eax
	}
}

__declspec(naked) void RecoverClipFix()
{
	__asm
	{
		mov    ebp, 4A5FE0h //start of OBPOS.DAT
		mov    cl, byte ptr [ebp+ecx]  
		mov    ebx, 0AAh
		xor    eax, eax
		xor    esi, esi
	loopstart:                  //loop to find all object similar to the current ammo object
		cmp    byte ptr [ebp], 0FFh
		jz     skip
		cmp    byte ptr [ebp], cl
		jnz    skip
		mov    al, byte ptr [ebp+8]   //adds the amount to the total amount
		add    si, ax
		mov    byte ptr [ebp], 0FFh
	skip:
		dec    ebx
		test   bl, bl
		jz     end
		add    ebp, 10h
		jmp    loopstart
	end:
		movsx  ebx, byte ptr [edi+26h]  //gets the ammo size for this clip from OBDATA.DAT
		mov    ax, si
		mov    esi, edx
		xor    edx,edx
		div    bx //divides the total rounds by full clip size, dropping any remainder
		mov    edx, esi
		movsx  esi, word ptr [edx]
		add    si, ax
		mov    word ptr [edx], si			        //adds the clips to the current BASE.DAT field					
		and    ebx, 0FFFFh
		mov    ecx, 447D6Fh
		jmp    ecx
	}
}

/*
 * Repopulate the activated proximity grenade list during each loop of the battlescape.
 * This is crude but effective. As an added bonus, it reduces the speed of the game ;-)
 * Better solution would be to update it only during unit movement.
 */
void FixProximityMines()
{
	__asm push ecx
	for(int i=0;i<20;i++) {
		tac_prox_mine_list[i].active=0;
	}
	int mine_idx=0;

	for(int i=0;i<170;i++)
	{
//		unsigned char *pObpos=&pObpos_dat[i*16];
		obpos_dat *pObpos=&pObpos_dat[i];
//		if(pObpos[0]==0x15&&pObpos[8]==1&&pObpos[4]==-1) //armed prox mine on the ground
		if(pObpos->itemType==0x15&&pObpos->quantity1==1&&pObpos->owner==0xff) //armed prox mine on the ground
		{
			tac_prox_mine_list[mine_idx].active=1;
			tac_prox_mine_list[mine_idx].pObpos=pObpos;
			mine_idx++;
			if(mine_idx==20)
				break;
		}
	}

	__asm pop ecx
	ActAccordingToTacticalState();
}

/*
 * Explosions give experience to the "current unit". For proxmines, developers forget to change it before generating
 * the explosion and the experience does not go to the correct unit.
 */
void FixProximityMinesExperience(int xpos, int ypos, __int16 zpos, int strength, int a, int b, __int16 c)
{
	unsigned char *pObpos;
	unsigned char thrower_idx;
	
	//save the current unit
	short saved_idx=*currentUnit_idx;

	__asm 
	{
		mov eax,[esi+2];
		mov pObpos,eax;
	}

	//set current unit to the thrower
	thrower_idx=pObpos[9];
	SetCurrentUnit(thrower_idx);
	
	//boom!
	GenerateExplosion(xpos, ypos, zpos, strength, a, b, c);

	//restore the current unit
	SetCurrentUnit(saved_idx);
}



const char *GetObjectDescription(const char *defaultDescription)
{
	unsigned char *pObpos=(unsigned char *)&pObpos_dat[*inventory_draggedItem_obPosIdx];
	static int init;
	static char primed[32];
	if(init==0) {
		init=1;
		INI_READ_STRING("Text","Primed","primed",primed,16);
	}

	switch(*inventory_draggedItem_objectType)
	{
	case 0x13://grenade
	case 0x14://smoke
	case 0x16://HE
	case 0x2c://alien grenade
	case 0x15://proximity
		if(pObpos[8]!=0)//quantity1
		{
			static char str[128];
			sprintf(str,"%s (%s)",defaultDescription,primed);
			return str;
		}
		//fall through
	default:
		return defaultDescription;
	}
}

__declspec(naked) void GrenadeState(void)
{
	static int saved;
	__asm
	{
		mov edx, [0x49D660+ecx*4]
		pusha
		push edx
		call GetObjectDescription
		add esp,4
		mov saved,eax
		popa
		mov edx, saved
		ret
	}
}

/*
 * Call the KillUnit function when an unconscious corpse is destroyed.
 * The KillUnit function generates a body and we don't want that. To prevent
 * it, we find which obpos will be used for the body (gotten with GetFreeObPosRef)
 * and clear the object after we called the function. Since big units can use
 * 4 objects, we check the 4 next obpos.
 */
void ObjectDestroyed(unsigned char *pObpos)
{	//int i;
	int flags=pObpos[12];
	if(flags&8) //unconscious corpse
	{
		int obtype=pObpos[0];
		if(obtype>=58&&obtype<=77) //big units: get out
			return;

		short corpse[4];
		int unitidx=pObpos[8];
		char *unitpos=&(unitpos_dat)[14*unitidx];
		char *unitref=*(char **)&(unitpos[4]);
		//*(char *)unitpos=pObpos[1];
		//*(char *)unitpos[1]=pObpos[2];
		//*(char *)unitpos[2]=pObpos[3];

		//save the next 4 free obpos
		for(int i=0;i<4;i++) //*
		{
			corpse[i]=GetFreeObPosRef();
		}

		Tactical_KillUnit(unitidx);

		//clear the obpos since they contain body objects
		for(int i=0;i<4;i++) //*
		{
			if(corpse[i]!=-1)
				pObpos_dat[corpse[i]].ypos=0xff;
		}

		//DrawDialog(&unitref[0x56],"got blasted");
	}
}

//Call the ObjectDestroyed function instead of just destroying the object by clearing its objType field
__declspec(naked) void CheckDestroyObject()
{
	__asm
	{
		jbe skip
		pusha
			
		sub esi,6
		push esi
		call ObjectDestroyed
		add esp,4

		popa
		mov     [esi-6], bl
skip:
		ret
	}
}

int CheckMindControl(int y, int x, int z)
{
	if(CheckIfClickedOnUnit(y,x,z))
	{
		SetFiringPointOrigin(*currentUnit_pUnitPos);
		if(CheckHasLineOfFire(y,x,z))
		{
			return 1;
		}
		*Tactical_StatusErrorMessage=7;//no line of fire
	}
	return 0;
}


__declspec(naked) void SectoidWeapons()
{
	__asm
	{
		mov     cl, byte ptr [edi]    //Current Weapon type
		mov     byte ptr [esp+34h], cl //CurrentObject variable
		xor		ecx, ecx
		mov		cl, byte ptr [ebp]   //Current Unit type
		cmp		cl, 4				//If not sectoid, skip
		jnz		end 
		cmp		byte ptr[ebp+2Ah], 3   //Sectoid rank is engineer or higher?
		mov		cl, byte ptr [esp+34h]
		jg		sectoidrank
		jz      engineer           //Only sectoid engineers get blaster launchers
		cmp		cl, 28h			   //leaders and commanders get rifles
		jnz		bbombcheck
		mov		cl, 24h
		jmp		final
	bbombcheck:
		cmp		cl, 29h
		jnz		engineer
		mov		cl, 25h
		jmp		final
	engineer:					//replaces all heavy plasma with rifles and appropriate clips
		cmp		cl, 22h
		jnz		ammo
		mov		cl, 24h
		jmp		final
	ammo:
		cmp		cl, 23h
		jnz		final
		mov		cl, 25h
		jmp		final
	sectoidrank:              //sectoid soldiers, navigators, and medics get plasma pistols for heavy plasmas.
		cmp		cl, 22h
		jz		pistol
		cmp		cl, 23h
		jz		ammo1
		cmp		cl, 24h
		jz		pistol
		cmp		cl, 25h
		jz		ammo1
		jmp		end
	pistol:
		mov		cl, 26h
		jmp		final
	ammo1:
		mov		cl, 27h
	final:
		mov		byte ptr [esp+34h], cl
	end:
		mov		cl, byte ptr [esp+34h]
		mov     [eax], cl
		mov     byte ptr [eax+1], 0
		mov		esi, 44FB3Dh
		jmp		esi
	}
}

/*__declspec(naked) void HotGrenade()
{
	__asm
	{
		call    AlienThrowGrenade
		push    64h
		call    Sleep_time
		add     esp, 4
		call    DetonatePrimedExplosives
		mov     ebx, 404EB4h
		jmp     ebx
	}
}*/

__declspec(naked) void HotGrenade1()
{
	__asm
	{

		cmp     byte ptr [ecx], 16h //high explosive
		jnz		noclock
		push    0
		call    DrawExplosiveTimer
		add     esp, 4
		cmp     ax, 0FFFFh
		jz      skip
		jmp     end
	skip:
		mov		ebx, 41E02Dh
		jmp		ebx
	noclock:
		xor		eax, eax
	end:
		mov     word ptr ds:4781E8h, 8
		mov     cl, byte ptr ds:4782A4h
		mov     edx, dword ptr ds:4781F8h
		add     cl, al
		mov     byte ptr [edx+8], cl
		mov		ebx, 41E00Eh
		jmp		ebx
	}
}

__declspec(naked) void HotGrenade2()
{
	__asm
	{
		call    UpdateShotsTU_4123E0
		mov     edi, dword ptr ds:4781F8h
		cmp     byte ptr [edi], 16h
		jz		skip
		push	0A0h
		call	Sleep_time
		add		esp, 4
		call	DetonatePrimedExplosives
	skip:
		mov		edi, 40F7B7h
		jmp		edi
	}
}

__declspec(naked) void HotGrenade3()
{
	__asm
	{
		call   AlienAI
		call   DetonatePrimedExplosives
		mov    eax, 401286h
		jmp    eax
	}
}


__declspec(naked) void AlienWeaponCheckCrash()
{
	__asm
	{
		movsx   eax, byte ptr [ecx]
		lea     eax, [eax+eax*2]
		lea     edx, [eax+eax*8]
		mov     eax, dword ptr ds:4A3F54h
		lea     ecx, [eax+edx*2]
		movzx   dx, byte ptr [eax+edx*2+23h]
		movzx   ax, byte ptr [ecx+25h]
		mov     [esp+18h], dx //var_18
		mov     [esp+14h], ax //var_1C
		movzx   dx, byte ptr [ecx+20h]
		movzx   ax, byte ptr [ecx+21h]
		movzx   bp, byte ptr [ecx+24h]
		mov     [esp+24h], dx //var_C
		mov     [esp+28h], ax //var_8
		movzx   dx, byte ptr [ecx+22h]
		mov     [esp+2Ch], dx //var_4
		mov		eax, 403637h
		jmp		eax
	}
}

__declspec(naked) void AltLaserDamage()
{
	__asm
	{
		mov   dword ptr [eax+0Ah], edx
		movzx edx, word ptr ds:4783EAh
		cmp   dl, 3
		jnz   skip
		mov   edx, dword ptr ds:4A3F54h // pointer to mem location of OBDATA.DAT
		movzx eax, byte ptr [edx+376h]
		mov   ecx, dword ptr ds:4781F8h //current object OBPOS mem location
		cmp   byte ptr [ecx], 10h
		jz    END
		cmp   byte ptr [ecx], 11h
		jnz   heavy
		//rifle
		test  byte ptr ds:46FE10h, 1
		jnz   tier2
		jmp   END
	heavy:
		test  byte ptr ds:46FE10h, 1
		jnz   tier3
		test  byte ptr ds:46FE26h, 1
		jnz   tier2
		jmp   END
	tier3:
		movzx eax, byte ptr [edx+3E2h]
	tier2:
		movzx eax, byte ptr [edx+3ACh]
	END:
		xor   ecx, ecx
		mov   word ptr ds:4783E8h, ax
	skip:
		movsx eax, bx
		mov   edx, 40DEBDh
		jmp   edx
	}
}

__declspec(naked) void ImprovedDetector()
{
	__asm
	{
		cmp    byte ptr ds:47059Ah, 0  //check if mind probe can be produced
		jz     improved 
normloopstart:
        movsx   ax, byte ptr [esi-0Ah]
        movsx   cx, byte ptr [ebp+0] //
		movsx   dx, byte ptr [ebp+1]
        sub     eax, ecx
        movsx   cx, byte ptr [esi-9] //
        sub     ecx, edx
        cmp     ax, 0FFF6h
        jle     loc_40B452
        cmp     ax, 0Ah
        jge     loc_40B452
        cmp     cx, 0FFF6h
        jle     loc_40B452
        cmp     cx, 0Ah
        jge     loc_40B452
        test    byte ptr [esi], 2
        jz      loc_40B452
        movsx   eax, ax
		mov     edx, dword ptr ds:4ADE30h
        lea     eax, [eax+eax*4]
        movsx   ecx, cx
        shl     eax, 6
        add     eax, ecx
        xor     ecx, ecx
        lea     edi, [edx+eax*8+737Ch]
        mov     eax, dword ptr [esi-6]
        mov     cl, byte ptr [eax+3Eh]
        mov     eax, 66666667h
        imul    ecx
        sar     edx, 1
        mov     ecx, edx
        shr     ecx, 1Fh
        add     edx, ecx
        test    dl, dl
        jz      loc_40B452
        cmp     dl, 5
        jbe     loc_40B433
        mov     dl, 5
loc_40B433:                             
		movzx   ax, byte ptr ds:4782AAh
        xor     cx, cx
        mov     cl, dl
        add     eax, ecx
        push    eax             // mov blip val
        push    edi             //dst
        call    Draw16x16Sprite
        mov     ebp, dword ptr ds:4A5FC0h
        add     esp, 8
loc_40B452:
        add     esi, 0Eh
        dec     ebx
        jnz     normloopstart
		mov     edx, 40ABA3h
		jmp     edx 
improved:
imploopstart:
        movsx   ax, byte ptr [esi-0Ah]
        movsx   cx, byte ptr [ebp+0] //
		movsx   dx, byte ptr [ebp+1]
        sub     eax, ecx
        movsx   cx, byte ptr [esi-9] //
		sub     ecx, edx
		cmp     ax, 0FFECh
		jle     loc_40B452a
		cmp     ax, 14h
		jge     loc_40B452a
		cmp     cx, 0FFECh
		jle     loc_40B452a
		cmp     cx, 14h
		jge     loc_40B452a
		test    byte ptr [esi], 2
		jz      loc_40B452a
		cmp 	byte ptr [esi-1], 1
		jnz		loc_40B452a
		cmp     ax, 0FFF6h
		jg      skipax
		mov     ax, 0FFF7h
	skipax:
		cmp     ax, 0Ah
		jl      skipax1
		mov     ax, 9
	skipax1:
		cmp     cx, 0FFF6h
		jg      skipcx
		mov     cx, 0FFF7h
	skipcx:
		cmp     cx, 0Ah
		jl      skipcx1
		mov     cx, 9
	skipcx1:
		movsx   eax, ax
		movsx   ecx, cx
		mov     edx, dword ptr ds:4ADE30h
		lea     eax, [eax+eax*4]
		shl     eax, 6
		add     eax, ecx
		xor     ecx, ecx
		lea     edi, [edx+eax*8+737Ch]
		mov     eax, dword ptr [esi-6]
		//mov     cl,  byte ptr [eax+3Eh]  code to check movement value
		test    byte ptr [esi], 4
		jz      smallunit
		cmp     byte ptr [eax], 0Ch
		jnz     moved
		test    byte ptr [esi], 8
		jnz     loc_40B452a
		test    byte ptr [esi], 10h
		jnz     loc_40B452a
		mov     cl, 4
		jmp     skip1
	smallunit:  
		cmp     byte ptr [eax], 9
		jz      moved
		mov     cl, 2
		jmp     skip1
	moved:
		test    byte ptr [esi], 8
		jnz     loc_40B452a
		test    byte ptr [esi], 10h
		jnz     loc_40B452a
		mov     cl, byte ptr [eax+3Eh] // code to check movement value
		test    cl, cl
		jz      skip1
		test    byte ptr [esi], 4
		jz      skip1
		//add     cl, 2
	skip1:
		mov     eax, 66666667h
		imul    ecx
		sar     edx, 1
		mov     ecx, edx
		shr     ecx, 1Fh
		add     edx, ecx
		cmp     dl, 5
		jbe     loc_40B433a
		mov     dl, 5
loc_40B433a:
		movzx   ax, byte ptr ds:4782AAh
		xor     cx, cx
		mov     cl, dl
		add     eax, ecx
		push    eax             
		push    edi             
		call    Draw16x16Sprite
		mov     ebp, dword ptr ds:4A5FC0h
		add     esp, 8
loc_40B452a:
		add     esi, 0Eh
		dec     ebx
		jnz     imploopstart
		mov     edx, 40ABA3h
		jmp     edx
	}
}