/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details.
 * Copyright (C) 2008-2010 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "patches.h"
#include "xcom.h"
#include "resource.h"
#include "shortcuts.h"
#include "roswell.h"
#include "smoke.h"
#include "hacks.h"
#include "intro.h"
#include "base.h"
#include "music.h"
#include "heavylaser.h"
#include "stun.h"
#include "video.h"
#include "interception.h"
#include "tacticalai.h"
#include "fire-smoke.h"
#include "objects.h"
#include "time.h"
#include "battleend.h"
#include "battlescape.h"
#include "ufopaedia.h"
#include "geoscape.h"

/* seb76TODO: 
 *  -base defense reset retaliation flag
 *  -psi attacks target random soldier
 *  -link to full stats in inventory
 *  -80 items limit??
 */

void LockCursor();

/*
 * Helper to draw dialog boxes
 */
void DrawDialog(char *line1, char *line2)
{
	//Draw box
	((void (*)(int,int,int,int,int))(0x41E3F0))(0x30,0x32,0x58,0xDC,1);


	*DrawText_leftBorder=0xA0;
	DrawString(line1,0x10,0x40,0x50,0);
	*DrawText_leftBorder=0xA0;
	DrawString(line2,0x10,0x50,0x50,0);
	*ui_numButtons=0;

	//"OK" button
	CreateButton(0x70,0x64,0x12,0x78,0x10,StringTable_battlescape[77]);

	((void (*)(int))(0x42F680))(1);

	WaitTilMouseButtonsAreReleased();
	while(!CheckForClickedButton());
}
void DrawDialog2(char num, char num2)
{
	//Draw box
	((void (*)(int,int,int,int,int))(0x41E3F0))(0x30,0x32,0x58,0xDC,1);


	*DrawText_leftBorder=0xA0;
	//DrawString(line1,0x10,0x40,0x50,0);
	DrawNumber2(num,0x10,0x40,0x50,0);
	*DrawText_leftBorder=0xA0;
	DrawNumber(num2,0x10,*carretPosition+5,0);
	*DrawText_leftBorder=0xA0;
	//DrawString(line2,0x10,0x50,0x50,0);
	*ui_numButtons=0;

	//"OK" button
	CreateButton(0x70,0x64,0x12,0x78,0x10,StringTable_battlescape[77]);

	((void (*)(int))(0x42F680))(1);

	WaitTilMouseButtonsAreReleased();
	while(!CheckForClickedButton());
}


ATOM __stdcall MyRegisterClassA(WNDCLASSA *lpWndClass)
{
	lpWndClass->hCursor = LoadCursor(hPatcherDLL, MAKEINTRESOURCE(IDC_EMPTY));
	lpWndClass->style = CS_HREDRAW | CS_VREDRAW;
	return RegisterClassA(lpWndClass);
}

void ClientResize(int nWidth, int nHeight);
HWND __stdcall MyCreateWindowExA(DWORD dwExStyle, LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle, int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam)
{
	char buf[128];
	int top,left,bottom,right;
	RECT rc;
	//INI_READ_STRING("Video","D3D Window Position","",buf,128);
	INI_READ_STRING("Video","D3D Window Position","",buf,64);
	//if(sscanf(buf,"%d %d %d %d",&top,&left,&bottom,&right) == 4)
	if(sscanf(buf,"%d %d",&left,&top) == 2)
	{
		right=INI_READ_INT("Video","D3D Window Width",0);
		bottom=INI_READ_INT("Video","D3D Window Height",0);
		SetRect(&rc,left,top,right,bottom);
		X=rc.left;
		if (X<0) X=0;
		Y=rc.top;
		if (Y<0) Y=0;
		AdjustWindowRect(&rc,WS_OVERLAPPEDWINDOW,FALSE);
		nWidth = rc.right - rc.left+left;
		nHeight = rc.bottom - rc.top+top;		
	}

	if(!INI_READ_INT("Video","Always On Top",0))
	{
		dwExStyle&=~WS_EX_TOPMOST;
	}

	return CreateWindowExA(dwExStyle, lpClassName, lpWindowName, WS_OVERLAPPEDWINDOW, X, Y, nWidth, nHeight, hWndParent, NULL, hInstance, lpParam);
//	return CreateWindowExA(dwExStyle, lpClassName, lpWindowName, dwStyle, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);
}


static DWORD WINAPI AnimationsThread(LPVOID lpThreadParameter)
{
	short *locationsOffset = (short *)0x4785EC;
	short *cursorFrame = (short *)0x4783A8;
	short *smokeFrame = (short *)0x4A5FBA;
	short *xxx=(short *)0x4783A6;
	char *currentUnitArrow=(char *)0x4783AA;

	*locationsOffset = 0;
	*smokeFrame = 0;
	while(true)
	{
		*locationsOffset = *locationsOffset?0:1;
		*xxx=*locationsOffset;
		*currentUnitArrow=(char)*locationsOffset;
		if(*cursorFrame == 3)
		{
			*cursorFrame = 0;
		}
		else
		{
			(*cursorFrame)++;
		}

		*smokeFrame=*cursorFrame;
		Sleep(100);
	}
}

void TacticalHook()
{
	*(int*)0x49C254=GetTime();
	if (INI_READ_INT("Video","Clip Cursor",0)>0) LockCursor();
	((void (*)())(0x42A700))();
}

void TacticalCursorUnlock()
{
	void UnlockCursor();
	UnlockCursor();
	ClipCursor(NULL);
	((void (*)())(0x42FDB0))();
}

void GeoCursorLock()
{
	LockCursor();
	((void (*)())(0x440F80))();
}

void FixAnimations()
{
//.text:0045769C 66 89 15 EC 85 47 00          mov     word_4785EC, dx
	Nop(0x45769C,7);
//.text:0042A881 66 89 0D A8 83 47 00          mov     word_4783A8, cx
//.text:0042A890 66 89 1D A8 83 47 00          mov     word_4783A8, bx
	Nop(0x42A881,7);
	Nop(0x42A890,7);

//.text:0042A888 66 A3 A6 83 47 00             mov     word_4783A6, ax
	Nop(0x42A888,6);

//.text:0042A8A8 66 A3 BA 5F 4A 00             mov     word_4A5FBA, ax
//.text:0042A8B0 66 89 1D BA 5F 4A 00          mov     word_4A5FBA, bx
	Nop(0x42A8A8,6);
	Nop(0x42A8B0,7);

//.text:00426880 88 0D AA 83 47 00             mov     byte_4783AA, cl
	Nop(0x426880,6);

	CreateThread(NULL,0,AnimationsThread,NULL,0,NULL);
}

void ForceLanguage()
{
#ifdef NDEBUG
	short lang=INI_READ_INT("Video","Force Language",1);
#else
	short lang=1;
#endif
	if(lang>0 && lang<4)
	{
		*language=lang-1;
	}
	else
	{
		//select language
		((void (*)())(0x44C650))();
	}
}

void LoadNewTextMsg()
{
((void (*)())(0x44C710))();
static char basehammer[128];
static char plasmacannon[256];
static char laserrifle[256];
static char shipcrash[256];
static char impdetector[512];
static char lift[128];

if(INI_READ_INT("Bug Fix","Craft Weapon Ufopaedia Fix",1)==1)
	{
		INI_READ_STRING("Text","plasma cannon","This is a devastatingly powerful weapon based on accelerating particles from within a minute anti-gravity field.",plasmacannon,256);
		*(char**)0x47A3CC=plasmacannon;
	}
if(INI_READ_INT("Bug Fix","Base Retaliation Loop Fix",1)==1) 
	{
		INI_READ_STRING("Text","base strike","The impact of the alien ship has destroyed the base",basehammer,128);
		*(char **)0x47B2B8=basehammer;
		INI_READ_STRING("Text","ship crash","The alien ship crashes into the base!",shipcrash,256);
		*(char **)0x47B2D4=shipcrash;
		INI_READ_STRING("Text","lift hit","The access lift has been damaged.",lift,128);
		*(char **)0x47B2DC=lift;
	}
if(INI_READ_INT("Mod","Alternate Tech Research",1)>=1)
	{
		INI_READ_STRING("Text","detector","Research on the alien mind probe allows us to double the range of detection as well as locate creatures by their mental activity.",impdetector,512);
		*(char **)0x47B2D8=impdetector;

		if(INI_READ_INT("Mod","Alternate Tech Research",1)>1)
		{
			INI_READ_STRING("Text","laser rifle","The laser rifle is lighter and more accurate than the older design.",laserrifle,256);
			*(char **)0x47AE18=laserrifle;
		}
	}
}


void SaveEquipment();
void EnableObDataPatching();

/*
 * Make visible the presence of the loader
 */
void ShowMod()
{   
	DrawString("UFO Extender @ www.ufopaedia.org",0x8B,0xB8,0x50,1); //52,88,1);
	((void (*)(int))(0x42F680))(1);
}

/*
 * Apply patches according to the ini file
 */

void ApplyPatches()
{
	{
		InsertCall(0x44A2F1,ShowMod);
		InsertCall(0x418C75, TacticalHook); //Setup for Cursor Lock and Battlescape Speed
		InsertCall(0x44B8DB,LoadNewTextMsg);
		InsertCall(0x44A124,LoadNewTextMsg);
	}

	if(INI_READ_INT("Mod","Doubleclick Movement",1))
	{
		InsertCall(0x42014C, CheckIfClickedOnUnitX);
		Nop(0x42015A, 16); //Nop out a few instructions to make the return codes work properly.
	}

	if(INI_READ_INT("Bug Fix","Crash On First Move",1))
	{
		int zero=0;
//		.text:00420645 E8 36 75 FF FF                call    GetTileAt
//		InsertCall(0x420645,MyGetTileAt);
//		.text:00420534 BE 01 00 00 00                mov     esi, 1
		PatchInPlace(0x420534+1,&zero,4);
//		.text:004022E5 BE 01 00 00 00                mov     esi, 1
		PatchInPlace(0x4022E5+1,&zero,4);
	}

	if(INI_READ_INT("Mod","Show Money",0))
	{
		ShowMoney();
	}
	if(INI_READ_INT("Mod","Auto sell",0))
	{
		AutoSell();
	}

	if(int capacity = INI_READ_INT("Mod","General Store Capacity",0)>50)
	{
		unsigned short cap = capacity * 10;
//		.text:00439C85 66 81 C5 F4 01                add     bp, 500
		if((unsigned int)cap*35>65535)
		{
			cap = 65535/35;
		}
		PatchInPlace(0x439C85+3,&cap,2);
		for (unsigned char i=0;i<95;i++)
		{
			unsigned short newsize;
			unsigned int offset=0x472B98+i;
			unsigned short oldsize=*(char *)(offset);
			newsize=oldsize;
			if (i>=0 && i<=9) newsize=(cap*oldsize)/625;
			if (i>9 && i<15) newsize=(cap*oldsize)/500;
			if (i==80 || i==81) newsize=(cap*oldsize)/500;
			if (i==93) continue;
			if (i<=94) newsize=(cap*oldsize)/625;
			PatchInPlace(offset,&newsize,1);
		}
	
			
//.text:00439E60 0F 8D E3 00 00 00             jge     loc_439F49
		char jae[] = {0x83};
		PatchInPlace(0x439E60+1,&jae,1);
//.text:00439E9D 66 3D F4 01                   cmp     ax, 1F4h
		PatchInPlace(0x439E9D+2,&cap,2);


//.text:0045639F 7E 14                         jle     short loc_4563B5
		char jbe[] = {0x76};
		PatchInPlace(0x45639F,&jbe,1);
//.text:004366A5 7C 11                         jl      short loc_4366B8
		char jb[] = {0x72};
		PatchInPlace(0x4366A5,&jb,1);
//.text:00438BAF 7C 17                         jl      short loc_438BC8
		PatchInPlace(0x438BAF,&jb,1);
	}

	if(INI_READ_INT("Bug Fix","Animations Speed",0))
	{
		FixAnimations();
	}

	if(INI_READ_INT("Video","D3D",0) && INI_READ_INT("Video","D3D Windowed",0))
	{
//		.text:0045DDF2 FF 15 4C 91 46 00             call    ds:RegisterClassA
		InsertCall(0x45DDF2,MyRegisterClassA);
		Nop(0x45DDF2+5);

//		.text:0045DE27 FF 15 2C 91 46 00             call    ds:CreateWindowExA
		InsertCall(0x45DE27,MyCreateWindowExA);
		Nop(0x45DE27+5);
/*
.text:0045DE53 56                            push    esi                             ; bShow
.text:0045DE54 FF 15 44 91 46 00             call    ds:ShowCursor
.text:0045DE5A 56                            push    esi                             ; hCursor
.text:0045DE5B FF 15 40 91 46 00             call    ds:SetCursor
*/
		Nop(0x45DE53,14);
	}

//	if(INI_READ_INT("Bug Fix","Low Fuel After Mission",0))
//	{
//.text:00457D6B 0C 02                         or      al, 2
//		Nop(0x457D6B,2);
//	}

	if(INI_READ_INT("Craft Ready Message","Apply",0))
	{
//		.text:0044287F 66 FF 0D 60 AA 49 00          dec     geo_num_rearming_crafts
		InsertCall(0x44287F,ShowCraftReadyBox);
		Nop(0x44287F+5,2);
	}

	if(INI_READ_INT("Mod","No Alien Freak Out Messages",0))
	{
//.text:0041F60F E8 BC 04 00 00                call    TacticalDrawPanicMessage
//.text:0041F7A5 E8 26 03 00 00                call    TacticalDrawPanicMessage
//.text:0041F58F E8 3C 05 00 00                call    TacticalDrawPanicMessage
		InsertCall(0x41F60F,MyTacticalDrawPanicMessage);
		InsertCall(0x41F7A5,MyTacticalDrawPanicMessage);
		InsertCall(0x41F58F,MyTacticalDrawPanicMessage);

		InsertCall(0x41F6BF,MyTactivalViewPosPanic);
		InsertCall(0x41FA40,MyTactivalViewPosPanic);
		InsertCall(0x41FB9B,MyTactivalViewPosPanic);
	}

	if(INI_READ_INT("Bug Fix","Hostile Civilians",1))
	{
		//.text:00413203 84 C9                         test    cl, cl
		//.text:00413205 0F 94 C2                      setz    dl
		InsertCall(0x413203,GetOwner);
	}

	if(INI_READ_INT("Mod","Alien Bleeding",0))
	{

		//.text:0040E1AB 8A 48 09                      mov     cl, [eax+structUnitPos.owner]
		//.text:0040E1AE 84 C9                         test    cl, cl
		InsertJmp(0x40E1AB, WoundCheck);

		//.text:0040E1B0 0F 85 04 01 00 00             jnz     loc_40E2BA
//		Nop(0x40E1B0,6);

		//Verbose death
		//.text:00413590 0F 85 92 00 00 00             jnz     continue
		//Nop(0x413590,6);
		//.text:0041326D 0F 85 98 00 00 00             jnz     loc_41330B
		//Nop(0x41326D,6);
	}

	if(INI_READ_INT("Mod","No Auto Wake Up",0))
	{
		//.text:00413560 E8 EB 00 00 00                call    WakeUnconsciousUnitUp
		Nop(0x413560,5);
	}

	if(INI_READ_INT("Hack","FPS",0))
	{
		InsertCall(0x44102F,DrawFPSGeo);
	}


	/*
	.text:004129FC 38 1D E4 83 47 00             cmp     isDuringReactionFire, bl        ; case 0x4
	*/
	if(0)
	{
		Nop(0x4129FC);
		InsertCall(0x4129FC + 1, CheckMainState);
	}
	//fog of war
	/*
	if(0)
	{
		//.text:0042683E E8 0D A1 00 00                call    sub_430950

		InsertCall(0x42683E,Fog);
		InsertCall(0x4269B2,Fog);
		InsertCall(0x401014,UpdateFogMap);
		InsertCall(0x42DD87,HookSeeMap);
//		InsertCall(0x42A703,FixSeeMap);
//		Nop(0x42A703+5);
	}
	*/

	//realtime terrain
	if(0)
	{
		InsertCall(0x420D61, UpdateTerrain);
	}

	if(INI_READ_INT("OBDATA.DAT","Apply",0))
	{
		EnableObDataPatching();
	}

	if(INI_READ_INT("Mod","Assign All Personnel",0))
	{
		if(INI_READ_INT("Mod","Human Limits",0)==1)
		{
			InsertJmp(0x434D34,AssignAllScientists2);
			InsertJmp(0x436319,AssignAllEngineers2);
		}
		else
		{
			//.text:00434D47 8A 04 0A                      mov     al, [edx+ecx]
			//.text:00434D4A 84 C0                         test    al, al
			InsertCall(0x434D47,AssignAllScientists);

			//.text:00436311 66 8B 84 71 8C 00 00 00       mov     ax, [ecx+esi*2+8Ch]
			//.text:00436319 66 3B C2                      cmp     ax, dx

			InsertCall(0x436311,AssignAllEngineers);
			Nop(0x436311+5,6);
		}

	}

	if(INI_READ_INT("Bug Fix","Funky Fire",1))
	{
		/*
		.text:0040D51C E8 7F C7 01 00                call    ApplyFireAndStunDamage
		.text:0040F092 E8 09 AC 01 00                call    ApplyFireAndStunDamage
		.text:0041074E E8 4D 95 01 00                call    ApplyFireAndStunDamage
		.text:00410ADB E8 C0 91 01 00                call    ApplyFireAndStunDamage
		*/
		Nop(0x40D51C,5);
		Nop(0x40F092,5);
		Nop(0x41074E,5);
		Nop(0x410ADB,5);
		InsertJmp(0x413171,FireDamageRoutine);
		InsertJmp(0x429DDA,StandInFireDamage);
		//InsertJmp(0x429E56,SmokeDamage);
		char patch[]={3};
		PatchInPlace(0x429E6F,patch,1);
		//mov    al, [esi]   90 8A 06
		//cmp    al, 01		 3C 01
		//jg     ....        7F
		//char smoke[]={0x90, 0x8A, 0x06, 0x3C, 0x01, 0x7F};
		//PatchInPlace(0x429E56,smoke,6);
		//PatchInPlace(0x429E92,smoke,6);
	}

	if(INI_READ_INT("Mod","TFTD Doors",1))
	{
		InsertCall(0x42010B,TryToOpenDoor);
	}

	if(INI_READ_INT("Mod","De-equip Crafts",1))
	{
		char cancelButtonWidth[]={0x46};
		PatchInPlace(0x456D5E+1,cancelButtonWidth,1);
		InsertCall(0x456D6B,CreateCraftDeequipButton);
//		.text:004569C1 0F 84 7F 01 00 00             jz      exit
		InsertJnz(0x4569C1,ExitCraftArmament);
	}

	if(INI_READ_INT("Mod","Funding Council Income Only",0))
	{
//.text:00448E22 A1 6C 3F 4A 00                mov     eax, carretPosition
//.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]
		InsertCall(0x448E22,IncomeOnlyItemPrice);
		Nop(0x448E27,3);
		InsertCall(0x4489AE,IncomeOnlyItemPrice2);
		Nop(0x4489AE+5);
		InsertCall(0x44892B,IncomeOnlyItemPrice3);
		Nop(0x44892B+5);
		
		
/*		
//		.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]
		char patch[]={0x33, 0xC9, 0x90};
		PatchInPlace(0x448E27,patch,3);

//.text:004489B4 29 15 38 A8 49 00             sub     dword_49A838, edx
		Nop(0x4489B4,6);
//.text:00448931 03 C2                         add     eax, edx
		Nop(0x448931,2);
*/
	}

	if(INI_READ_INT("Bug Fix","Personnel Overflow",1))
	{
		InsertCall(0x4415E3,FixScientistsEngineersOverflow);
		Nop(0x4415E3+5);
		InsertCall(0x44160C,FixScientistsEngineersOverflow);
		Nop(0x44160C+5);
	}


	if(INI_READ_INT("Mod","Limited Military",0))
	{
//		.text:0043B133 BE 08 00 00 00                mov     esi, 8
		unsigned char numSoldiers=INI_READ_INT("Mod","Limited Military",0);
		PatchInPlace(0x43B134,&numSoldiers,1);

//		.text:00436CE8 B9 62 07 47 00                mov     ecx, offset purchaseInfo.canBeBought
		InsertCall(0x436CE8,DisableSoldierPurchase);

//Reduce wage
//		.text:0043BFD7 C1 E0 05                      shl     eax, 5
		unsigned char shift[]={2};
		PatchInPlace(0x43BFD7+2,shift,1);
	}

	if(INI_READ_INT("Bug Fix","Door Jam",1))
	{
		InsertCall(0x41B97B,FixDoorJam);
	}

	if(INI_READ_INT("Mod","No Funkers",0))
	{
		/*
		.text:00449262 E8 99 02 00 00                call    GetSoldierScoreForPromotion
		.text:0044930B E8 F0 01 00 00                call    GetSoldierScoreForPromotion
		.text:004493BF E8 3C 01 00 00                call    GetSoldierScoreForPromotion
		.text:00449473 E8 88 00 00 00                call    GetSoldierScoreForPromotion
		*/
		InsertCall(0x449262,GetScoreForPromotion);
		InsertCall(0x44930B,GetScoreForPromotion);
		InsertCall(0x4493BF,GetScoreForPromotion);
		InsertCall(0x449473,GetScoreForPromotion);

	}

	if(INI_READ_INT("Mod","Bloodthirst",0))
	{
		//	0f b7 c2	 movzx	 eax, dx
		char patch[]={0x0f,0xb7,0xc2};
		PatchInPlace(0x4495BD,patch,3);
		Nop(0x4495BD+3,7);
	}

	extern void Shortcuts();

	//shortcuts
	if(INI_READ_INT("Battlescape Shortcuts","Apply",0) || INI_READ_INT("Geoscape Shortcuts","Apply",0) || (INI_READ_INT("Video","D3D",0) && INI_READ_INT("Video","D3D Windowed",0)))
	{
		Shortcuts();
	}


	if(INI_READ_INT("Caps","Apply",0))
	{
		char jae[] = {0x73};

		//.text:0044741D B8 50 00 00 00                mov     eax, 80                         ; TUs cap
		unsigned char TU=INI_READ_INT("Caps","Time Units",80);
		PatchInPlace(0x44741D+1,&TU,1);

		//.text:0044745C B8 3C 00 00 00                mov     eax, 60                         ; Health cap
		unsigned char health=INI_READ_INT("Caps","Health",60);
		PatchInPlace(0x44745C+1,&health,1);

		//.text:0044749B B8 46 00 00 00                mov     eax, 70                         ; Strength cap
		unsigned char strength=INI_READ_INT("Caps","Strength",70);
		PatchInPlace(0x44749B+1,&strength,1);

		//.text:004474DA B8 64 00 00 00                mov     eax, 100                        ; Energy cap
		unsigned char energy=INI_READ_INT("Caps","Energy",100);
		PatchInPlace(0x4474DA+1,&energy,1);

		//.text:0044751D 83 FA 64                      cmp     edx, 100                        ; Reactions cap
		unsigned char reactions=INI_READ_INT("Caps","Reactions",100);
		PatchInPlace(0x44751D+2,&reactions,1);
		//.text:00447520 7D 44                         jge     short loc_447566
		PatchInPlace(0x447520,jae,1);

		//.text:00447572 83 FA 78                      cmp     edx, 120                        ; Firing accuracy cap
		unsigned char fa=INI_READ_INT("Caps","Firing Accuracy",120);
		PatchInPlace(0x447572+2,&fa,1);
		//.text:00447575 7D 44                         jge     short loc_4475BB
		PatchInPlace(0x447575,jae,1);

		//.text:004475C7 83 FA 78                      cmp     edx, 120                        ; Melee accuracy cap
		unsigned char ma=INI_READ_INT("Caps","Melee Accuracy",120);
		PatchInPlace(0x4475C7+2,&ma,1);
		//.text:004475CA 7D 44                         jge     short loc_447610
		PatchInPlace(0x4475CA,jae,1);

		//.text:0044761C 83 FA 78                      cmp     edx, 120                        ; Throwing accuracy cap
		unsigned char ta=INI_READ_INT("Caps","Throwing Accuracy",120);
		PatchInPlace(0x44761C+2,&ta,1);
		//.text:0044761F 7D 44                         jge     short loc_447665                ; psi skill
		PatchInPlace(0x44761F,jae,1);

		//.text:00447665 80 7E 33 64                   cmp     byte ptr [esi+33h], 100         ; psi skill cap
		unsigned char ps=INI_READ_INT("Caps","Psi Skill",100);
		PatchInPlace(0x447665+3,&ps,1);
	}

	if(INI_READ_INT("Initial Base","Apply",0))
	{
		SafeBaseDesign();
	}

	if(INI_READ_INT("Line Of Fire Check","Mind Control",0))
	{
		//.text:0041EE52 E8 99 13 00 00                call    CheckIfClickedOnUnit
		InsertCall(0x41EE52,CheckMindControl);
	}
	if(INI_READ_INT("Line Of Fire Check","Panic",0))
	{
//		.text:0041F132 E8 B9 10 00 00                call    CheckIfClickedOnUnit
		InsertCall(0x41F132,CheckMindControl);
	}
	if(INI_READ_INT("Line Of Fire Check","Mind Probe",0))
	{
//		.text:0041FD50 E8 9B 04 00 00                call    CheckIfClickedOnUnit
		InsertCall(0x41FD50,CheckMindControl);
	}

	if(INI_READ_INT("Bug Fix","Intro Sounds",0))
	{
		FixIntroSounds();
	}	
/*
	//force retaliation
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x432AD8,patch,6);
		PatchInPlace(0x432B06,patch,2);
		PatchInPlace(0x4594BD,patch,6);
	}
//*/

	//move soldiers in ship
	if(INI_READ_INT("Mod","Reorder Soldiers In Crafts",1))
	{
		//.text:00455EFD E8 9E A2 FF FF                call    DrawString
		InsertCall(0x455EC7,CrewDlgAddUpDownButton);

//		.text:00455CEE E8 AD 7B FE FF                call    WaitTillMouseButtonsAreReleased
		InsertCall(0x455CEE,CrewHook);
	}

	//Stun
	if(INI_READ_INT("Mod","Stun Fest",0))
	{
		extern int stunActivated;
		stunActivated=1;

		if(!INI_READ_INT("Mod","Heavy Laser",0))
		{
			ModStun();
		}
	}
	//Heavy laser MUST be after stun fest or combination won't work
	if(INI_READ_INT("Mod","Heavy Laser",0))
	{
		ModHeavyLaser();
	}

	int fast=INI_READ_INT("Mod","Fast Base Defenses",0);
	if(fast)
	{
		Nop(0x4484C9,5);
		Nop(0x4484ED,5);
		Nop(0x44852E,5);
		Nop(0x4485F0,5);
		Nop(0x448629,5);
		Nop(0x448674,5);
		Nop(0x4486CE,5);
		Nop(0x448773,5);
		Nop(0x448788,5);
		Nop(0x4487A8,5);

		if(fast==2) //remove the button press
		{
			Nop(0x4487E0,2);
		}
	}


	//Create some bases from the begining
	if(INI_READ_INT("Mod","Initial Alien Bases",0))
	{
		//.text:004513A8 call    CreateXComBase
		InsertCall(0x4513A8,CreateInitialAlienBases);
	}

	if(INI_READ_INT("Mod","Disable Base Defenses",0))
	{
		//.text:004578FC E8 8F 0A FF FF                call    ActivateBaseDefensesAgainstAlienShip
		char patch[]={0x33,0xC0,0x90,0x90,0x90}; //xor eax,eax
		PatchInPlace(0x4578FC,patch,5);
	}

	if(INI_READ_INT("Mod","Surrender Defence Missions",0))
	{
//		.text:00457913 E8 A8 2D 00 00                call    AreThereSoldiersInBase
		char patch[]={0x33,0xC0}; //xor eax,eax
		PatchInPlace(0x457913,patch,2);
		Nop(0x457913+2,3);
	}

	if(INI_READ_INT("Range Based Accuracy","Apply",0))
	{
		InsertCall(0x42669F,DrawAccuracy);
		Nop(0x42669F+5,2);

		InsertCall(0x4266D6,DrawPCKSpriteCursorHook);
		
		//aimed/snap shot
		InsertCall(0x40D369,RangeBasedAccuracy);

		//autoshot
		InsertCall(0x40EDFB,RangeBasedAccuracy);

		//reaction fire
		InsertCall(0x4105A4,ReactionFireAccuracy);

		LoadAccuracyParameters();
	}

	if(INI_READ_INT("Mod","More Smoke",0))
	{
		ModMoreSmoke();
	}

	//base maintenace estimate
	if(INI_READ_INT("Bug Fix","Displayed Base Maintenance Cost",1))
	{
		char patch[]={
			0x03, 0xc0,			// add eax,eax
			0x8a, 0x04, 0xc1,	// mov al, BYTE PTR [ecx+eax*8]
			0x0f, 0xb6, 0xc0,	// movzx	 eax, al
			0x90, 0x90, 0x90, 0x90, 0x90 //nops
		};
		PatchInPlace(0x440651,patch,13);
		Nop(0x44066E,3);
	}

	//Base build stacking
	if(INI_READ_INT("Mod","Base Building Stacking",0))
	{
		ModBaseBuildingStacking();
	}

	//Roswell mod. Scout ships can crash randomly
	if(INI_READ_INT("Roswell","Apply",0))
	{
		ModRoswell();
	}
	
	if(INI_READ_INT("Mod","Keep Base Navigation Modules",1))
	{
		Nop(0x415066,9);
	}

	//crafts always ready
	if(INI_READ_INT("Mod","Crafts Always Ready",0))
	{
		//Check fuel level instead of state
		char patch[]={0x18,0x03,0x7c};
		PatchInPlace(0x45174E+4,patch,3);
	}

	if(INI_READ_INT("Mod","Stunned units KIA",0))
	{
		//Keep cursor enabled during alien turn to be able to click the dialog box
		Nop(0x401019,5);
		//Keep cursor while moving in case proxmine kills a body
		Nop(0x420370,5);

		InsertCall(0x40CEB3,CheckDestroyObject);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Video","D3D",0) || INI_READ_INT("Video","HQ4x",0) || INI_READ_INT("Video","Video Pitch",0))
#endif
	{
#ifdef NDEBUG
		if(INI_READ_INT("Video","D3D",0))
		{
			if(INI_READ_INT("Video","HQ4x",0))
				SetScalingMethod(4);
			else
				SetScalingMethod(3);
		}
		else if(INI_READ_INT("Video","HQ4x",0))
			SetScalingMethod(2);
		else if(INI_READ_INT("Video","Video Pitch",0))
			SetScalingMethod(1);
#else
		SetScalingMethod(3);
#endif
	}
	
	if(INI_READ_INT("Mod","No Blaster Bomb Drift",0))
	{
		Nop(0x426E78,5);
		Nop(0x40595F,5);
	}
	else if(INI_READ_INT("Bug Fix","Collectors Edition Blaster Bomb Bug",1))
	{
		InsertCall(0x426E78,FixedAccuracyCompensation);
		InsertCall(0x40595F,FixedAccuracyCompensation);
	}

	if(INI_READ_INT("Mod","More Reaction Fire",0))
	{
		InsertCall(0x42192B,ReactionFire1);
		InsertCall(0x421921,ReactionFire2);
	}

	if(INI_READ_INT("Mod","Manual Interception Fire Mode",0))
	{
		Nop(0x446B61,2);
		Nop(0x446AE8,6);
		Nop(0x447120,13);  //don't fallback on taking damage
		//InsertJmp(0x446AC1, LastShotFallbackFix);
	}

	if (INI_READ_INT("Video","Clip Cursor",0))
	{
		//InsertCall(0x418C75, TacticalCursorLock);
		InsertCall(0x418C35, LockCursor); // locks the cursor on a game load if its a battle.

		if (INI_READ_INT("Video","Clip Cursor",0)==1)
		{
			InsertCall(0x418C84, TacticalCursorUnlock);			
		}
		if (INI_READ_INT("Video","Clip Cursor",0)==2)
		{
			InsertCall(0x440836, GeoCursorLock);
		}
	}

	if(INI_READ_INT("Video","Battlescape Delay",0))
	{
		unsigned char speed=INI_READ_INT("Video","Battlescape Delay",0);
		PatchInPlace(0x42A8CE,&speed,1);
		if(INI_READ_INT("Battlescape Shortcuts","Apply",0))
		{
			InsertJmp(0x42A827,TimeFix2s);
		}
		else InsertJmp(0x42A827,TimeFix2);
	}

	if(INI_READ_INT("Video","Slow Geoscape Clock",0))
	{
		char timepref=(INI_READ_INT("Video","Slow Geoscape Clock",0));
		if(timepref==1)
		{
			Nop(0x440812,5);   //removes uneeded reference
			Nop(0x4593A2,14);
			InsertJmp(0x440EEB,SlowGeoClock);
			char min[]={2};
			char min2[]={0x01};
			PatchInPlace(0x440D2C,min,1);
			PatchInPlace(0x44127B,min2,1);
			char fivemin[]={0x06}; 
			char fivemin2[]={0x4}; 
			PatchInPlace(0x440D37,fivemin,1);
			PatchInPlace(0x441280,fivemin2,1);
			char thirmin[]={0xC,0}; 
			PatchInPlace(0x440D42,thirmin,2);
			PatchInPlace(0x441267,thirmin,2);
			char hour[]={0x78,0};    
			PatchInPlace(0x440D4D,hour,2);
			PatchInPlace(0x4412A4,hour,2);
			char day[]={0xD0,2}; 
			PatchInPlace(0x440D58,day,2);
			PatchInPlace(0x4412AB,day,2);
		}
		else
		{
		   InsertJmp(0x440EEB,SlowGeoClock2);
		}
	}

#ifdef NDEBUG
	if(INI_READ_INT("Video","Skip Intro",0))
#endif
	{
		Nop(0x45E69F,5);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Equipment Screen","Show Stats",0)) 
#endif
	{
		//Patch coordinates of "TUs>" string
		char patchy[]={ 0x18+8 };
		char patchx[]={ 0xFA-5 };
		PatchInPlace(0x418E9E,patchy,1);
		PatchInPlace(0x418E99,patchx,1);
		InsertJmp(0x419482,ShowEncumberance);
	}


#ifdef EQUIPMENT
	void SaveEquipment();
	void InitNewGeoGameHook();
	void SaveTacticalGameHook(char *slot);
	void SaveGeoGameHook(char *slot);
	void LoadGameHook(char *slot);
	extern int auto_flares;

	if(INI_READ_INT("Equipment Screen","Save Equipment",0))
	{
		//.text:00418C61 E8 5A 16 00 00                call    Tactical_EquipTeamDisplay
		InsertCall(0x418C61,SaveEquipment);
//.text:0044A166 E8 D5 0A FF FF          call    InitNewGeoGame
		InsertCall(0x44A166,InitNewGeoGameHook);

//.text:00415B89 E8 92 04 00 00          call    SaveTacticalData
		InsertCall(0x415B89,SaveTacticalGameHook);

//.text:0044A7EC E8 CF 03 00 00          call    SaveGeoGameData
		InsertCall(0x44A7EC,SaveGeoGameHook);

//.text:0044A59A E8 11 14 00 00          call    LoadGeographGame
		InsertCall(0x44A59A,LoadGameHook);

		if(INI_READ_INT("Equipment Screen","Auto Flares",0))
			auto_flares = 1;

	}
#endif


	if(INI_READ_INT("Equipment Screen","Show Grenade State",0))
	{
		//.text:00418FEB 8B 14 8D 60 D6 49 00          mov     edx, StringsTable2_tactical[ecx*4]
		InsertCall(0x418FEB,GrenadeState);
		Nop(0x418FEB+5,2);
	}


	if(INI_READ_INT("Music","Apply",0)) 
	{
		ModMusic();
	}
	//CD/mp3 music do not have the freeze bug. The 2 patches would not work together anyway...
	else
#ifdef NDEBUG
	if(INI_READ_INT("Bug Fix","Music Change Freeze",0))
#endif
	{
		ClickPauseBug();
	}


	if(INI_READ_INT("Wreck Analysis","Apply",0))
	{
		InsertCall(0x4482B0,WreckAnalysis);
	}

/////////////////Bug Fixes/////////////////////

	//elerium ships
	if(INI_READ_INT("Bug Fix","Elerium-fueled Craft Bug",1))
	{
		InsertCall(0x4421AC,EleriumShipFix);
	}

	//Force the fix if using Crafts always ready to prevent transfered crafts from being stuck
	if(INI_READ_INT("Bug Fix","Transfered Crafts Refueled",1) || INI_READ_INT("Mod","Crafts Always Ready",0))
	{
//		044151F 66 C7 44 10 18 00 00    
		Nop(0x44151F,7);
	}

	if(INI_READ_INT("Bug Fix","Radar Stacking",1))
	{
		InsertJmp(0x439D10,FixRadarStacking);
	}

	if(INI_READ_INT("Bug Fix","Base Facility Dismantle-Construction Crash",1))
	{
		BaseFacilityDismantleConstructionCrash();
	}

	if(INI_READ_INT("Bug Fix","Tactical Scroll",0))
	{
		if(!INI_READ_INT("Video","D3D",0)) //Useless with D3D
		{
			char patch_vsync[]={DDFLIP_WAIT};
			PatchInPlace(0x45C89D,patch_vsync,1); 
			InsertCall(0x4147D5,TimeFix);
			Nop(0x45C891,2); 
		}
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades",1)) 
	{
		InsertCall(0x42A7D6,FixProximityMines);
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades Experience",1))
	{
		InsertCall(0x41E239,FixProximityMinesExperience);
	}

	if(INI_READ_INT("Bug Fix","Pay For Dirt",1)) 
	{
		char patch[]={0xff, 0xff, 0xff, 0xff};
		PatchInPlace(0x43BE4E,patch,4);
	}

	if(INI_READ_INT("Bug Fix","Phantom Radar",1)) 
	{
		//char patch[]={0xeb, 0x43A2D2-0x43A290-5};
		///PatchInPlace(0x43A290,patch,2);
		InsertJmp(0x43A2D5,PhantomRadarFix);
	}

	if(INI_READ_INT("Bug Fix","Base Disjoint",1))
	{
		InsertCall(0x41AFCA,BaseDisjointFix);
	}

	if(INI_READ_INT("Bug Fix","Tactical Sounds Fix",1))
	{
		Nop(0x425232,9);
		char zombie[]={0x00};
		PatchInPlace(0x46D1F0,zombie,1); //Zombie movement now based on tileset
		char rod[]={0x06};
		PatchInPlace(0x45DC76,rod,1); //Enable Stun Rod sound event
		char rod2[]={0x36};
		PatchInPlace(0x475954,rod2,1); //Set SAMPLE2.CAT reference for stun rod
		char snake[]={0x80};
		PatchInPlace(0x45D881,snake,1);//fix sound for Snakeman movement
		char celatid[]={0xC0};
		PatchInPlace(0x45D8A7,celatid,1); //fix sound for Celatid movement
		char patch2[]={0xC2};
		PatchInPlace(0x45DB36,patch2,1);//properly disable unneccessary sound events
		char patch3[]={0x06};
		PatchInPlace(0x45DC8C,patch3,1); //enable Celatid attack efx
		char patch4[]={0x33};
		PatchInPlace(0x4759AC,patch4,1); //set correct SAMPLE2.CAT reference for Celatid attack
	}
	
	if(INI_READ_INT("Bug Fix","Craft Weapon Ufopaedia Fix",1))
	{
		char patch[]={0x0F,0xBF,0x40,0x02,0x83,0xE8,0x05};
		PatchInPlace(0x45B204,patch,7);
		InsertCall(0x45B20B,CraftWeaponInfo);
		Nop(0x45B210,304);
		InsertCall(0x45C2C9,UP_UFO_info);
		Nop(0x45C2CE,14);
		char patch2[]={0x34};
		PatchInPlace(0x45C320,patch2,1); 
		char Xpos[]={0xC5};
		PatchInPlace(0x45C24B,Xpos,1); //shifts number to the right
		PatchInPlace(0x45C28B,Xpos,1);
		PatchInPlace(0x45C307,Xpos,1);
	}

	if(INI_READ_INT("Bug Fix","UFO Responds to Interception",1))
	{
		InsertCall(0x446BE2,UFOresponse); //
		Nop(0x446BE7,2); //
		InsertJmp(0x4470B9,Adjust_UFOaccuracy);
		//char pat1[]={0x0A};
		//PatchInPlace(0x445D3B,pat1,1);  //base UFO escape time-(diff*10)
		//Nop(0x445D3C,3); // sub dx,cx  (base UFO escape time-(diff*30))
		InsertCall(0x446B41,UFOdelta);
		Nop(0x446B46,18);
	}

	if(INI_READ_INT("Bug Fix","Alien Weapon Selection Crash Fix",1))
	{
		/*  3B CB					cmp ecx,ebx  [ebx=0]
			0F 84 A3 03 00 00		jz  loc_403999
		*/
		char patch[]={0x3B,0xCB,0x0F,0x84,0xA3,0x3,00,00};
		PatchInPlace(0x4035EE,patch,8); 
		InsertJmp(0x4035F6, AlienWeaponCheckCrash);
	}

	if(INI_READ_INT("Bug Fix","Alien Attacks Base Location Fix",1))
	{
		
		InsertJmp(0x4032C3,AlienAttackBaseFix);	 //old - PatchInPlace(0x4032C5,patch,3);
		char jmp[]={0x1A};                       //old - PatchInPlace(0x40330A,patch,3);
		PatchInPlace(0x4032F9,jmp,1);           //make the code jump past the status check on the current target since the target is a location
		char patch[]={0xC0,0x5F,0x4A};
		PatchInPlace(0x410B03,patch,3);
	}

	if(INI_READ_INT("Bug Fix","Tank/Cannon Ammo Storage Fix",1))
	{
		char patch[]={0};
		PatchInPlace(0x472BF5,patch,1);
	}

	if(INI_READ_INT("Bug Fix","Clip Weight Fix",1))
	{
		InsertCall(0x4199F7, ClipFixHook1); //eu
		Nop(0x4199FC,13);
		InsertCall(0x419870, ClipFixHook1); //eu
		Nop(0x419875,12);
		InsertCall(0x419886, ClipFixHook2); //eu
		Nop(0x41988B,4);
		InsertCall(0x419A0B, ClipFixHook3); //eu
		Nop(0x419A10,8);
		InsertJmp(0x41FC2A, ClipFixPanic); //eu 
		char panic[]={0x90,0x33,0xC0};			// xor eax, eax
		PatchInPlace(0x41FC2F,panic,3);
		Nop(0x41FC32,4);
		InsertJmp(0x40F56C, ClipFixHook5); //eu
		Nop(0x40F571,5);
	}
	
	if(INI_READ_INT("Bug Fix", "Zombie Fix",1))
	{
		InsertJmp(0x406787,ZombieItemFix);
		Nop(0x40678C,3);
		InsertJmp(0x4096F3,ChrysFix);
		char scream[]={0x2A};
		PatchInPlace(0x46B666,scream,1); //sets the zombie death scream to reaper rather than human.
		char espfix[]={0x28};
		PatchInPlace(0x4067B0,espfix,1);
		InsertJmp(0x409647,ZombieMCFix);
		Nop(0x40965E,3);
		Nop(0x40967A,4); //remove the assignment of the chryssalid corpse to the unit. Now set by patch according to new unit type.
		Nop(0x40E83A,9); //removes check to see if civilain killed by UPS. Why is this here at all?
	}

	if(INI_READ_INT("Bug Fix", "Unconscious Unit MC fix",1))
	{
		InsertCall(0x40E8AA, KoMCfix);
	}

	if(INI_READ_INT("Bug Fix","EOB fix",1))
	{
		Nop(0x4148C5,4); //eu
		InsertCall(0x413134,EOB_PreCheck);
		InsertCall(0x417AF5,AbortPreEOB); //eu
		InsertJmp(0x417942,UnitCountFix); //eu
		//InsertCall(0x4160F5,KOUnitFix);
	}

	if(INI_READ_INT("Bug Fix","Large Unit MC Fix",1))
	{
		InsertJmp(0x41F0B4, LargeUnitMCFix);
		Nop(0x41F0B9,13);
	}

	if(INI_READ_INT("Bug Fix","Large Unit Explosion Fix",1))
	{
		InsertJmp(0x40D008,LargeUnitExplosionFix);
	}

	if(INI_READ_INT("Bug Fix","Weapon Loadout Fix",1))
	{
		if(INI_READ_INT("Mod","Alt Weapon Loadouts",0)==0)
		{
			char scout[]={0x25};
			PatchInPlace(0x472D75,scout,1);
			char leader[]={0x26, 0x27, 0x27};
			PatchInPlace(0x472EA9, leader, 3);
		}
	}
 
	if(INI_READ_INT("Bug Fix","Armor Modifier Fix",1))
	{
		char personal[]={0x7E};
		PatchInPlace(0x44EECC,personal,1);
	}

	if (INI_READ_INT("Bug Fix","No Freebies for Tanks",1))
	{
		InsertJmp(0x44ED1A,BaseTankLoadFix);
		Nop(0x44ED1F,20);
	}

	if (INI_READ_INT("Bug Fix","Recover Clips Fix",1))
	{
		InsertJmp(0x447D5B,RecoverClipFix);
		Nop(0x447D60,15);                   //Removes old code that fix replaces
		Nop(0x447D8D,4);					//Removes old that added 1 to list in base stores.
	}

	if(INI_READ_INT("Bug Fix","Bezerk Unit Crash Fix",1))
	{
		InsertJmp(0x41F36A, BezerkCrashFix);
		char patch[]={0x55};
		PatchInPlace(0x41F3B0,patch,1);
	}

	if(INI_READ_INT("Bug Fix","Tank Death Penalty Fix",1))
	{
		char score[]={0xB1,0x14,0x90};
		PatchInPlace(0x44ECA6,score,3);
	}

	if(INI_READ_INT("Bug Fix","Slow Death Screams on Alien Turn",1))
	{
		InsertJmp(0x40E4C3,AlienTurnSlowFix);
	}

	if(INI_READ_INT("Bug Fix","Smoke&Fire Propagate Fix",1))
	{
		InsertJmp(0x429559,SmokeFix1);
		Nop(0x42955E,29);             //remove all unused bits
		InsertJmp(0x429679,SmokeFix2);
		Nop(0x42967E,29);
		InsertJmp(0x4297AC,SmokeFix3);
		Nop(0x4297B1,32);
		InsertJmp(0x4298CF,SmokeFix4);
		Nop(0x4298D4,29);
		InsertJmp(0x429261,FirePropFix1);
		InsertJmp(0x4292B6,FirePropFix2);
		InsertJmp(0x42931C,FirePropFix3);
		InsertJmp(0x429378,FirePropFix4);
	}

	if(INI_READ_INT("Bug Fix","Explosion Fix",1))
	{
		InsertJmp(0x40B4FE,ExplosionCenterFix); //40C494
		char patch[]={0x33, 0xDB, 0x90};  //xor ebx, ebx
		PatchInPlace(0x40B503,patch,3);
		InsertJmp(0x40C767,ExplFix1);
		InsertJmp(0x40C944,ExplFix2);
		InsertJmp(0x40C51F,ExplFix3);
		InsertJmp(0x40C701,ExplFix4);
		InsertJmp(0x40C4BC,ExplFix4);
		InsertJmp(0x40CB32,ExplFix5);
	}

	if(INI_READ_INT("Bug Fix","Terror Mission Score Fix",1))
	{
		InsertJmp(0x414C0B,TerrorScoreFix);
	}

	if(INI_READ_INT("Bug Fix","Research Medic Crash Fix",1))
	{
		InsertJmp(0x445213,MedicResearchFix);
	}

	if(INI_READ_INT("Bug Fix","Base Retaliation Loop Fix",1))
	{
		InsertJmp(0x448597,BaseDefensesAmmoCheck);
		InsertJmp(0x4486D6,BaseDefensesUFOResponse);
		InsertJmp(0x4487A6,RetaliationMsg);
		Nop(0x44845B,9);                    //removes the skip for no base defenses.
		InsertJmp(0x43188D,VaryRetaliationShip);
		InsertJmp(0x41B2F3,BombAirlock);
		//char patch[]={0xFF};
		//PatchInPlace(0x447A7B,patch,1);
		InsertJmp(0x447A70,HammerCheck);
		InsertJmp(0x4577AA,HammerFall);
		InsertJmp(0x45779B,HammerFall2);
		InsertJmp(0x45790E,BaseHammer);

		char patch1[]={0xC3};
		PatchInPlace(0x44C80D,patch1,1);
	}	

	if(INI_READ_INT("Bug Fix", "Grenade Throw Test Fix",1))
	{
		InsertJmp(0x42BD16,GrenadeStrTestFix);
	}

	if(INI_READ_INT("Bug Fix","Alien Base Exploit Fix",1))
	{
		InsertJmp(0x441DAB,AlienBaseScoreFix);
		char patch[]={0x90,0x90,0x90,0x33,0xC9};  //xor  ecx,ecx
		PatchInPlace(0x441DB0,patch,5);
	}

	if(INI_READ_INT("Bug Fix","Base Defense Prep",1))
	{
		InsertCall(0x457920,BaseDefenseBriefing);	//457935
		Nop(0x44CF5E,180);						//452463
		char patch[]={0x18};
		PatchInPlace(0x44D014,patch,1);
		Nop(0x44D015,5);						//4524A2
		Nop(0x44D01D,10);						//452510
		InsertJmp(0x44EA44,BaseDefensePrep); 
	}

	/////////////////Enhancements///////////////////


if (INI_READ_INT("Mod", "More Chryssalid Sound Effects",1))
	{
		InsertCall(0x40E2D2,Chrys_BurstSound1);
		InsertCall(0x40E30A,Chrys_BurstSound1);
		char attack[]={0xE7};
		PatchInPlace(0x4067CC,attack,1);
		char Ref[]={0x31};
		PatchInPlace(0x4759B8,Ref,1); //Set Sample2.Cat reference for zombify sound event
		char Event[]={0x06};
		PatchInPlace(0x45DC8F,Event,1);//Activate and set play style for zombie event
		char Event2[]={0x01};
		PatchInPlace(0x45DC8A,Event2,1); //Make Chrysallid attack efx play uninterrupted
	}

if(INI_READ_INT("Mod","Start With All Missiles",0))
	{
		char aval[]={0x03};
		PatchInPlace(0x43B1BB,aval,1); //Sets ammo value for right-hand weapon
		char av_launch[]={0x01};        //Sets right-hand weapon slot to avalanche launcher
		PatchInPlace(0x43B1C2,av_launch,1); //Interceptor 1
		PatchInPlace(0x43B1F2,av_launch,1); //Interceptor 2
		char zero[]={0x00};
		PatchInPlace(0x46F22A,zero,1); //zero avalanche launchers left in base 
		PatchInPlace(0x46F22C,zero,1); //zero cannons in base 
		PatchInPlace(0x46F238,zero,1); //zero cannon ammo in base
		char avalanche[]={0x10};
		PatchInPlace(0x46F236,avalanche,1);  //+6 avalanche missiles for price diff (2cannon+9ammo-1 av laucher=~54000/9000=6)
	}

if(INI_READ_INT("Mod","Difficulty Level of Interceptions",0))
	{
		Nop(0x446DEA,2);
		Nop(0x446DF4,18);
		InsertCall(0x446E06,AdjustHitAccuracy);
		Nop(0x4470B7,2);
		if(INI_READ_INT("Mod","Know Thy Enemy",0)==1)
		{
		InsertCall(0x4470F1,Adjust_UFOdamage); 
		Nop(0x4470F6,10);
		}
	}

if(INI_READ_INT("Mod","True Cautious Mode",0))
	{
		InsertCall(0x44692F,AdjustCautiousMode);
		Nop(0x446934,1);
		InsertCall(0x446B9E,CautiousRangeSelect);
		Nop(0x446BA3,21);
	}
	
if(INI_READ_INT("Enhanced Tactical AI","Apply",0))
	{
		static int max_auto_range;
		static int max_snap_range;
		char Hmax_auto[2];
		char Hmax_snap[2];
		max_auto_range=INI_READ_INT("Enhanced Tactical AI","Autofire Distance",8);
		max_snap_range=INI_READ_INT("Enhanced Tactical AI","Snap Distance",16);
		itoa(max_auto_range,Hmax_auto,16); 
		itoa(max_snap_range,Hmax_snap,16);
		PatchInPlace(0x42BD80,Hmax_auto,1);
		PatchInPlace(0x42BD98,Hmax_snap,1);
		tacticalAIpatch();
		InsertJmp(0x403A0C,SnakeTerrorAI1);
		Nop(0x403A11,12);
		InsertJmp(0x404F66,SnakeTerrorAI2);
		Nop(0x404F6B,21);
	}

if(INI_READ_INT("Mod","Ablative Armor",0))
	{
		InsertJmp(0x40DF8D,ArmorMod1);
		Nop(0x40DF92,4);
		InsertJmp(0x40DFB6,ArmorMod2);
	}

if(INI_READ_INT("Mod","Know Thy Enemy",0))
	{
	InsertJmp(0x40DFEB, DamageMod);
	InsertCall(0x40E12C, StunMod);
	Nop(0x40E131,6);
	if (INI_READ_INT("Bug Fix","Change Sectopod Laser Modifer",1))
		{
		char sectopod[]={0x64};
		PatchInPlace(0x46DEC2,sectopod,1);
		}
	if(INI_READ_INT("Mod","Know Thy Enemy",0)>1)
		{
		InsertJmp(0x446E13,DSPlans);
		Nop(0x446E3C,2);
		InsertCall(0x4470F1,Adjust_UFOdamage); 
		Nop(0x4470F6,10);
		}
	}

if (INI_READ_INT("Mod","Improved Laser Tank",0))
	{
		//char prereq[]={0xA8};
		//PatchInPlace(0x448990,prereq,1);			//UNUSED for laser tank: this made aqua plastics a prerequisite for tank/Gauss in TFTD
		InsertCall(0x44EBCB, TankStats);
		Nop(0x44EBD0,85);						//Removes the bytes that TankStat() replaces.
		PatchInPlace(0x470418,"0x58",1); //Sets the production need for Alloy
		PatchInPlace(0x47041B,"5",1);    //sets the amount needed to 5 units.
		InsertCall(0x45BECC,ImpTankUP1); 
		InsertCall(0x45BF0F,ImpTankUP2);
		InsertCall(0x45BF52,ImpTankUP3); 
		InsertCall(0x45BF96,ImpTankUP4);
		InsertCall(0x45BFD8,ImpTankUP5);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Mod","Save Reserve Mode",1)) 
#endif
	{
		InsertCall(0x401014,SaveReserveMode);
		InsertCall(0x4012F6,RestoreReserveMode);
	}

	if(INI_READ_INT("Mod","Hot Grenades",0)) 
	{
		//Nop(0x41E095,6);  this just disabled checks to see if grenade was held. Modern Grenades have safety catch to prevent 
		// this kind of accident. Lets make grenades exlode when thrown to prevent the passing of armed grenades.  One could still
		//set a live grenade down from inventory but necessary to simulate handing the grenade to another.
		InsertJmp(0x41DFED,HotGrenade1);
		InsertJmp(0x40F7B2,HotGrenade2);
		InsertJmp(0x401281,HotGrenade3);
	}

	if(INI_READ_INT("Mod","Alien Inventory",1)) 
	{
		Nop(0x412A20,8);
	}

	if(INI_READ_INT("Mod","Retaliate Against Ground Assault",0)) 
	{
		InsertCall(0x44720A,RetaliationAfterGroundAssault);
	}

	if(INI_READ_INT("Mod","Rank In Inventory",0)) 
	{
		InsertCall(0x41A581,DrawRank);
		InsertCall(0x418E8C,DrawRank);
//		Nop(0x41A43E,2);
	}

	InsertCall(0x44A11F,ForceLanguage);

	if(INI_READ_INT("Mod","Zombies Will Hatch",0))
	{
		InsertJmp(0x4097E9,SetZombieTimer);
		Nop(0x4097EE,1);
		InsertCall(0x41311A,CheckZombieTimers);
		InsertCall(0x429CE5,ZombieFireDamage);
	}

	if(INI_READ_INT("Mod","EU2012 Item Rules",0))
	{
		InsertJmp(0x40E63A,ItemDest);
		char clearedx[]={0x33,0xD2,0x90}; 
		                //33 D2          xor    edx,edx
		                //   90          nop
		PatchInPlace(0x40E63F,clearedx,3);
		InsertJmp(0x429FF6,BurnItems);
		Nop(0x429FFB,11);
		Nop(0x41F617,5); //Units will not drop weapons on Panic
	}

	if(INI_READ_INT("Mod","Weak Sectoids",0))
	{
		InsertJmp(0x44FB31,SectoidWeapons);
		Nop(0x44FB36,7);  //Just omits the unnecessary bytes as a precaution.
	}

	if(INI_READ_INT("Mod","Alternate Research Tree",0))
	{
		char jump[]={0xEB};
		InsertJmp(0x44473B,HyperwaveMod);
		Nop(0x444740,15);						//removes the old code.
		InsertJmp(0x444B67,ResearchMod);
		Nop(0x444B6C,75);						//Nop B6C~BB6  removes old code
		char patch[]={0x8B,0x74,0x24,0x18};		//mov  esi, [esp+14h+arg_0]
		PatchInPlace(0x444BB7,patch,4);
		InsertJmp(0x40AB07,ImprovedDetector);
		InsertJmp(0x45B7F9,ImpDetectorUP);
		//Makes psionics available only after interrogating an etheral. Get access to mind shield after interrogate sectoid leaders or an etheral.
		InsertJmp(0x4447B5,AltPsionicReasearchTree);
		Nop(0x4447BA,21);
											///PatchInPlace(0x4447BE,jump,1);
											//Nop(0x4447C0,5);
			//end psionics
		//Laser Cannon & tank production
		Nop(0x444A58,14);
		char patch4[]={4};
		PatchInPlace(0x444A6D,patch4,1);
			//end laser
		PatchInPlace(0x444AA8,jump,1);			//jumps past the section to unlock mind probe production
		//Blaster bomb 
		Nop(0x444ACD,7);
		char patch8[]={8};
		PatchInPlace(0x444ADD,patch8,1);
			//end blaster 
		char e115[]={0x3C};
		char eNum[]={5};
		if(INI_READ_INT("Mod","Improved Laser Tank",0)==1)
		{
			PatchInPlace(0x470419,e115,1);		//sets the need for 5 elerium units as second production material
			PatchInPlace(0x47041C,eNum,1);
		}
		else
		{
			PatchInPlace(0x470418,e115,1);		//set elerium as the first production material
			PatchInPlace(0x47041B,eNum,1);
		}
		PatchInPlace(0x470496,e115,1);
		char eNum2[]={0xA};
		PatchInPlace(0x470499,eNum2,1);
		char laser[]={0x37,00,0x50,00,0x1E,00,0xA,00,04,00,00,00,0xFF};
		PatchInPlace(0x46FB62,laser,13);
		char heavy[]={0x1F};
	if(INI_READ_INT("Mod","Alternate Tech Research",0)>1)
		{
			InsertJmp(0x45B60D,AltLaserTechUP);
			AltLaserWeaponResearch();
			InsertJmp(0x40DEB7,AltLaserDamage);
		}
	}

	if(INI_READ_INT("Mod","Alt Weapon Loadouts",0))
	{
		char scout[]={0x26, 0x27, 0x2E, 00, 00, 0x24, 0x25, 0x2E, 00, 00, 0x22, 0x23, 0x2E, 00, 00};
		PatchInPlace(0x472D6E,scout,15);
		char medium1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char medium2[]={0x26, 0x27, 0x2E, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 00, 00, 00};
		PatchInPlace(0x472D83,medium1,15);
		PatchInPlace(0x472D98,medium2,15);
		char large1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 00, 00, 00};
		char large2[]={0x26, 0x27, 0x2E, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char large3[]={0x26, 0x27, 0x2E, 00, 00, 0x24, 0x25, 0x2E, 00, 00, 0x2A, 0x2B, 0x2B, 00, 00};
		PatchInPlace(0x472DAD,large1,15);
		PatchInPlace(0x472DC2,large2,15);
		PatchInPlace(0x472DD7,large3,15);
		char harvester1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char harvester2[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 0x2C, 00, 00, 0x22, 0x23, 00, 00, 00};
		char harvester3[]={0x2A, 0x2B, 0x2B, 00, 00, 0x2A, 0x2B, 0x2B, 00, 00, 0x2A, 0x2B, 0x2B, 0x2B, 00};
		char harvester4[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 00, 00, 00};
		char harvester5[]={0x26, 0x27, 0x2C, 00, 00, 0x24, 0x25, 0x2C, 00, 00, 0x22, 0x23, 0x2C, 0x2C, 00};
		PatchInPlace(0x472DEC,harvester1,15);
		PatchInPlace(0x472E01,harvester2,15);
		PatchInPlace(0x472E16,harvester3,15);
		PatchInPlace(0x472E2B,harvester4,15);
		PatchInPlace(0x472E40,harvester5,15);
		char abductor1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00}; 
		char abductor2[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00}; 
		char abductor3[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 0x2C, 00, 00, 0x22, 0x23, 0x23, 00, 00};
		char abductor4[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char abductor5[]={0x25, 0x26, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		PatchInPlace(0x472E55,abductor1,15);
		PatchInPlace(0x472E6A,abductor2,15);
		PatchInPlace(0x472E7F,abductor3,15);
		PatchInPlace(0x472E94,abductor4,15);
		PatchInPlace(0x472EA9,abductor5,15);
		char terror1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 0x2C, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char terror2[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 00, 00, 00};
		char terror3[]={0x26, 0x27, 0x2C, 00, 00, 0x24, 0x25, 0x2C, 00, 00, 0x2A, 0x2B, 0x2B, 00, 00}; 
		char terror4[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char terror5[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		PatchInPlace(0x472EBE,terror1,15);
		PatchInPlace(0x472ED3,terror2,15);
		PatchInPlace(0x472EE8,terror3,15);
		PatchInPlace(0x472EFD,terror4,15);
		PatchInPlace(0x472F12,terror5,15);
		char battle1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char battle2[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char battle3[]={0x26, 0x27, 00, 00, 00, 0x2A, 0x2B, 0x2B, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char battle4[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x28, 0x29, 0x29, 00, 00};
		char battle5[]={0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00, 0x28, 0x29, 0x29, 00, 00}; 
		char battle6[]={0x22, 0x23, 0x2C, 0x2C, 00, 0x22, 0x23, 0x2C, 0x2C, 00, 0x28, 0x29, 0x29, 00, 00};
		PatchInPlace(0x472F51,battle1,15);
		PatchInPlace(0x472F66,battle2,15);
		PatchInPlace(0x472F7B,battle3,15);
		PatchInPlace(0x472F90,battle4,15);
		PatchInPlace(0x472FA5,battle5,15);
		PatchInPlace(0x472FBA,battle6,15);
		char supply1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char supply2[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char supply3[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x2A, 0x2B, 0x2B, 00, 00};
		char supply4[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char supply5[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		PatchInPlace(0x472FF9,supply1,15);
		PatchInPlace(0x47300E,supply2,15);
		PatchInPlace(0x473023,supply3,15);
		PatchInPlace(0x473038,supply4,15);
		PatchInPlace(0x47304D,supply5,15);
		char base1[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char base2[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		char base3[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x2A, 0x2B, 0x2B, 00, 00}; 
		char base4[]={0x26, 0x27, 00, 00, 00, 0x24, 0x25, 00, 00, 00, 0x28, 0x29, 0x29, 00, 00};
		char base5[]={0x24, 0x25, 00, 00, 00, 0x22, 0x23, 0x2C, 00, 00, 0x28, 0x29, 0x29, 00, 00};
		char base6[]={0x22, 0x23, 0x2C, 00, 00, 0x22, 0x23, 0x2C, 00, 00, 0x22, 0x23, 0x2C, 00, 00};
		PatchInPlace(0x47308C,base1,15);
		PatchInPlace(0x4730A1,base2,15);
		PatchInPlace(0x4730B6,base3,15);
		PatchInPlace(0x4730CB,base4,15);
		PatchInPlace(0x4730E0,base5,15);
		PatchInPlace(0x4730F5,base6,15);
	}

	if(INI_READ_INT("Mod","Human Limits",0))
	{
		InsertJmp(0x434D1C,ScientistLimits);
		char jump[]={0x7E};
		PatchInPlace(0x434D15,jump,1);
		
		InsertJmp(0x434E3C,ScientistLimits3);
		char patch[]={0x5F,0x5E,0x5B,0xC3};
		PatchInPlace(0x434E41,patch,4);
		InsertJmp(0x441CD4,ScientistLimits4);
		InsertJmp(0x4362D0,EngineerLimits);
		InsertJmp(0x435236,EngineerLimits2b);
		Nop(0x435A8E,3);
		InsertJmp(0x435AEE,EngineerLimits3);
		char patch2[]={0x5B,0xC3};
		PatchInPlace(0x435AF3,patch2,2);
		InsertJmp(0x4416C9,EngineerLimits4);
		if(INI_READ_INT("Mod","Assign All Personnel",0)==0)
		{
			InsertJmp(0x434D34,ScientistLimits2);
			InsertJmp(0x436319,EngineerLimits2);
		}
	}

//////////////////Hacks////////////////////
	
#ifdef NDEBUG
	if(INI_READ_INT("Hack","No Score Game Over",0)) 
#endif
	{
		HackNoScoreGameOver();
	}

	if(INI_READ_INT("Hack","No Alien Psi",0)) 
	{
		HackNoAlienPsi();
	}

	if(INI_READ_INT("Hack","Directly Use Alien Weapons",0)) 
	{
		HackDirectlyUseAlienWeapons();
	}

	if(INI_READ_INT("Hack","Recover All Clips",0))
	{
		 HackRecoverAllClips();
	}

	if(INI_READ_INT("Hack","Show All Locations",0))
	{
		HackShowAllLocations();
	}

	InsertJmp(0x425455,HackDebugFlagsCheck);
}
