/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details. 
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "interception.h"
#include "patcher.h"
#include "xcom.h"
#include "patches.h"

__declspec(naked) void GrenadeAImod()
{
	__asm
		{
               mov     al, [esi+7]
               cmp     al, 1         //target faction=alien
               jz      loc_4051FB
			   cmp     al, 2      //target faction=civilian
			   jnz     here
			   mov	   eax, dword ptr ds:4A3E88h  //currentunit unitref
			   cmp     byte ptr [eax], 5  //snakeman
			   jz      end
			   here:
			   mov     eax, [esp+10h]
               add     eax, 3
               jmp     loc_4051FE
			   loc_4051FB:
			   mov     eax, [esp+10h]
               sub     eax, 3
			   loc_4051FE:
			   mov     [esp+10h], eax
			   end:
			   mov     eax, 405202h
			   jmp     eax
		}
} 



__declspec(naked) void SnakeTerrorAI1()
{
	__asm
	{
		mov   ax, word ptr ds:4A3EB4h  //mission type
		cmp   ax, 1                   //terror site
		jnz   usual
		mov   eax, dword ptr ds:4A3E88h  //current unit unitref offset
		cmp   byte ptr [eax], 5
		jnz   usual
		cmp   word ptr ds:4782A4h, 14h  //current turn
		jg    usual
		mov   al, byte ptr [esi+8]
		cmp   al, 0
		jnz   skip
		mov   ecx, 403A1Dh
		jmp   ecx
		usual:
		mov   al, byte ptr [esi+8]
		mov   cl, byte ptr ds:4781C8h
		cmp   al, cl
		jz    skip
		mov   ecx, 403A1Dh
		jmp   ecx
		skip:
		mov   ecx, 403BA5h
		jmp   ecx
	}
}

//Supposed to stop snakes from throwing grenades at civilains but seems to have no effect...more research needed.
__declspec(naked) void SnakeTerrorAI2()
{
	__asm
	{
		cmp   byte ptr [eax+1], 2
		jnz   xcom
		cmp   byte ptr [ecx], 5
		jnz   xcom
		cmp   word ptr ds:4782A4h, 14h  //current turn
		jle   skip
		xcom:
		mov     cl, byte ptr [eax-8]
		mov     dl, byte ptr [eax-7]
		mov     bl, byte ptr [eax-6]
		mov     dword ptr [esp+1Ch], 0 //var_18
		test    si, si
		jle     skip
		mov     eax, 404F80h
		jmp     eax
		skip:
		mov     ecx, 4050CFh
		jmp     ecx
	}
}

void GetBaseTile2Throw()
{
	if(*(short*)0x477BC6!=0 && *(char*)(*(int*)0x4A3E88)!=4) //if alien has grenade and is not sectoid
	{
		short ypos=*(char*)(*(int*)0x4A5FC0); // *(short*)0x477BC8;  // 
		short xpos=*(char*)((*(int*)0x4A5FC0)+1); //*(short*)0x477BCA; // 
		short zpos=*(char*)((*(int*)0x4A5FC0)+2); //*(short*)0x477BCC; // 
		short x=(xpos/10);
		short y=(ypos/10);
		x=x*10;
		y=y*10;
		short maxdistance=0;
		short maxX=xpos;
		short maxY=ypos;
		char targetitem=0;
		int unitref=*(int*)0x4A3E88;
		for(char i=0;i<10;i++) //y
			{
				short y1=y+i;
				for(char k=0;k<10;k++) //x
				{
					short x1=x+k;								
					unsigned char item=*(char*)(GetTileAt(x1,y1,*(char*)0x477BCC)+3);
					if(item>0)
					{
						char target=*(char*)(0x4A925C+(item*62));
						if(target==1)
						{
							if(item>targetitem) targetitem=item; 
							*(char*)0x47843A=*(char*)(unitref+17);  //unitstrengt
							*(char*)0x47843C=1; //use arc trajectory
							*(short*)0x478438=3;  //item weight
							SetFirePointOrigin(*(int*)0x4A5FC0);
							char grenade=CanThrow2Tile(y1,x1,zpos);
							if(grenade==1)
							{
								short distance=GetDistance(y1,x1,ypos,xpos); //
								if(distance>maxdistance)
								{
									maxdistance=distance;
									maxX=x1;
									maxY=y1;
								}
								*(char*)0x47843C=0; //use arc trajectory
							}
						}
					}
				}
			}
		if(targetitem>=63 || targetitem<=65) {maxX=x+4;maxY=y+6;}
		if(targetitem==131) {maxX=x+2;maxY=y+3;}
		*(short*)0x477BCA=maxX;
		*(short*)0x477BC8=maxY;
		*(char*)((*(int*)0x4A3E88)+0x7A)=0xFF;
		} 	
}

_declspec(naked) void TryGrenadeBaseTargetHook()
{
	__asm
	{
		call    CheckBaseLocations
		test    al, al
		jz      skip
		call    GetBaseTile2Throw
		//newcode
		call    AlienTryGrenade
		mov     ecx, dword ptr ds:4A3E88h
		mov     byte ptr [ecx+7Ah], 0 
		mov     ecx, dword ptr ds:4A5FC0h
		test    byte ptr [ecx+0Ah], 2  //alien disabled
		jnz     next						
		mov		word ptr ds:4782BAh, 6  //alien status=KO/dead
		mov		eax, 407EE2h				//if alien is killed/disabled by the grenade, raise a flag and abort the rest of AI routine.
		jmp     eax
      next:
		movzx   edx, word ptr ds:477BCCh
		movzx   eax, word ptr ds:477BCAh
		movzx   ecx, word ptr ds:477BC8h
		mov     ebx, 407DC5h //E4h
		jmp     ebx
skip:
		mov     ecx, 407E30h
		jmp     ecx
	}
}


__declspec(naked) void SetNodeTargetForGrenade()
{
	__asm
		{
		mov     eax, dword ptr ds:4A3E88h
		cmp     byte ptr [eax+7Ah], 0FFh
		jz      nodeattack
		mov     eax, dword ptr ds:4BA3C8h
		test    eax, eax
		jz      findtarget
		movzx   si, byte ptr [eax+2]
		movzx   di, byte ptr [eax+1]
		movzx   bp, byte ptr [eax]
		mov     dword ptr [esp+18h], esi //var_C], esi
		mov     ecx, 404CB9h
		jmp     ecx
	findtarget:
		mov     eax, 404C75h
		jmp     eax
	nodeattack:
		movzx   esi, word ptr ds:477BCCh //Z
		movzx   edi, word ptr ds:477BCAh //X eax
		movzx   ebp, word ptr ds:477BC8h //Y ecx
		mov     dword ptr [esp+18h], esi //var_C], esi
		xor     eax, eax
		xor     edx, edx 
		mov     ecx, 404CB9h
		jmp     ecx  
		}
}

__declspec(naked) void UseGrenadeOnNodeAI()
{
	__asm
		{
		mov    dword ptr [esp+10h], 0
		mov    esi, dword ptr ds:4A3E88h
		cmp    byte ptr [esi+7Ah], 0FFh
		jnz    skip
		mov    dword ptr [esp+10h], 0Fh
	skip:
		mov    esi, 405130h
		jmp    esi
		}
}

void tacticalAIpatch()
{
	char ai1[]={0x10};
	PatchInPlace(0x40363E,ai1,1);
	char ai2[]={0x25};
	PatchInPlace(0x40370D,ai2,1);
	char ai3[]={0x64};
	PatchInPlace(0x4046ED,ai3,1);
	//BB and Grenade AI mod
	InsertJmp(0x4051ED, GrenadeAImod);
	///char ai4[]={0x75};
	///PatchInPlace(0x4051F6,ai4,1);
	//char ai4a[]={0x48};
	///PatchInPlace(0x4051F8,ai4a,1);
	///char ai4b[]={0xC0,3};
	///PatchInPlace(0x4051FC,ai4b,2);
	//char ai4[]={0xC0}; original Kyrub
	//PatchInPlace(0x404D48,ai4,1); original Kyrub
	char ai5[]={0x32};
	PatchInPlace(0x404D64,ai5,1);
	Nop(0x406255,13);
	char ai6a[]={0x19};
	PatchInPlace(0x4062AA,ai6a,1);
	PatchInPlace(0x4062B1,ai6a,1);
	char ai6b[]={0x4B};
	PatchInPlace(0x4062B9,ai6b,1);
	char ai7[]={0x07};
	PatchInPlace(0x4074D9,ai7,1);
	char ai8[]={0xD1};
	PatchInPlace(0x4074DD,ai8,1);
	char ai9[]={0x03, 0xC8, 0xC1, 0xE1, 0x06, 0xB8, 0x1F, 0x85, 0xEB, 0x51};
	PatchInPlace(0x4074DF,ai9,10);
	char ai0A[]={0xC6};
	PatchInPlace(0x4076C8,ai0A,1);
	char ai0B[]={0xF2};
	PatchInPlace(0x4076E6,ai0B,1);
	char ai0C[]={0x04, 0x40};
	PatchInPlace(0x407746,ai0C,2);
	char ai0D[]={0x80};
	PatchInPlace(0x40774A,ai0D,1);
	char ai0E[]={0x90, 0xD1, 0xE7};
	PatchInPlace(0x4078C4,ai0E,3);
	char ai0F[]={0x90, 0xC1, 0xF8, 0x03, 0x66, 0x85, 0xC0, 0x66, 0x29, 0x05};
	PatchInPlace(0x42BD1C,ai0F,10);
	char ai10[]={0x2D, 0x01};
	PatchInPlace(0x44F92D,ai10,2);
	char node1[]={0xBB,01,00,00,00}; //mov  ebx, 1 
	PatchInPlace(0x407DC5,node1,5);  //E4
	InsertJmp(0x407DAC,TryGrenadeBaseTargetHook);
	InsertJmp(0x404C58,SetNodeTargetForGrenade);
	InsertJmp(0x405128,UseGrenadeOnNodeAI);
//	InsertJmp(0x404D04,UseGrenadeOnNodeAI2); 
}