/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "xcom.h"
#include "patches.h"

void CraftWeaponInfo()
{
	int Weapon_idx, ESI, FireRateTable;
	short UFOp_entry, Range, Damage, Accuracy, Cycle;
	char *pWeapon_name, *pWeapon_text;
	
	__asm	mov Weapon_idx, eax
	
	UFOp_entry=*(int *)(0x46FB18+(Weapon_idx*18));
	ESI=(0x46FB18)+(Weapon_idx*18);
	FireRateTable=(0x473FB8)+Weapon_idx*6;
	Range=*(short *)(ESI+2);
	Damage=*(short *)(ESI+6);
	Accuracy=*(short *)(ESI+4);
	Cycle=(*(short *)(FireRateTable+2))/2;
	pWeapon_name=languageStuff_geoscape[UFOp_entry];
	pWeapon_text=languageStuff_geoscape[Weapon_idx+6];
	DrawString(pWeapon_name, (0xF0), (0x18), 5, 0); 	
	DrawString(languageStuff_geoscape[421],(0xF0),(0x50), 5, 0); 
	DrawNumber(Damage,(0xF5),(*carretPosition), 0);	// weapon damage
	DrawString(languageStuff_geoscape[422],(0xF0),(0x60), 5, 0);
	DrawNumber(Range,(0xF5),(*carretPosition), 0);
	DrawString(languageStuff_geoscape[423],(0xF5), 0,(0xFFFF), 0); //"km"
	DrawString(languageStuff_geoscape[424],(0xF0),(0x70), 5, 0);
	DrawNumber(Accuracy,(0xF5),(*carretPosition),0);
	DrawString("%",(0xF5),0,(0xFFFF),0);
	DrawString(languageStuff_geoscape[425],(0xF0),(0x80), 5, 0);
	DrawNumber(Cycle,(0xF5),(*carretPosition),0);
	DrawString(languageStuff_geoscape[426],(0xF5), 0,(0xFFFF), 0); //"s"
	*(short *)(0x4782B0)=(0x12C);
	DrawString(pWeapon_text,(0xF0),(0x98), 5, 1);
}

void UP_UFO_info()
{
	int Urange, Num1, Font;
	
	__asm 
	{
		mov Num1, edx
		mov Font, esi
	}
	
	Urange=Num1/8;
	DrawNumber2(Urange,(0x86),(0x64),(0xC5),Font);
	DrawString("km",(0x86),(0x44),(0xFFFF),Font);
}

__declspec(naked) void ImpTankUP1()
{
	__asm
	{
		xor		eax, eax          
		cmp     word ptr [edi+2], 2
		mov		al, [esi+0Ch]        
		jnz		normal
		mov		al, 78h           
	normal:
		ret
	}
}

__declspec(naked) void ImpTankUP2()
{
	__asm
	{
		xor		edx, edx
		cmp     word ptr [edi+2], 2
		mov		dl, [esi+0Dh]
		jnz		normal
		mov		dl, 69h
	normal:
		ret
	}
}

__declspec(naked) void ImpTankUP3()
{
	__asm
	{
		xor		ecx, ecx
		cmp     word ptr [edi+2], 2
		mov		cl, [esi+0Eh]
		jnz		normal
		mov		cl, 69h
	normal:
		ret
	}
}

__declspec(naked) void ImpTankUP4()
{
	__asm
	{
		xor		eax,eax
		cmp     word ptr [edi+2], 2
		mov		al, [esi+0Fh]
		jnz		normal
		mov		al, 5Ah
	normal:
		ret
	}
}

__declspec(naked) void ImpTankUP5()
{
	__asm
	{
		xor		edx,edx
		cmp     word ptr [edi+2], 2
		mov		dl, [esi+10h]
		jnz		normal
		mov		dl, 5Ah
	normal:
		ret
	}
}

__declspec(naked) void ImpDetectorUP()
{
	__asm
	{
		xor     edx, edx
		push    1
		mov     dx, [ecx+6]
		push    8
		push    eax
		push    0F0h
		mov     eax, ds:47A3A0h[edx*4]
		push    eax
		call    DrawString
		add     esp, 14h
		mov     ecx, [esp+14h]
		cmp     word ptr [ecx+2], 17h
		jnz     skip
		cmp     byte ptr ds:47059Ah, 0
		jnz     skip
		mov     word ptr ds:4782B0h, 12Ch
		mov     eax, dword ptr ds:47B2D8h
		push    1
		push    8
		push    93h
		push    0F5h
		push    eax
		call    DrawString
		add     esp, 14h
skip:
		mov     ebx, 45B819h
		jmp     ebx
	}
}

__declspec(naked) void AltLaserTechUP()
{
	__asm
	{
		movzx   dx, byte ptr [esi+16h]
		cmp     byte ptr [esi+1Fh], 3
		jnz     NEXT
		mov     ecx, dword ptr [esp+28h] //14h
		movzx   ecx, word ptr [ecx+2]
		cmp     cx, 10h
		jz      NEXT
		cmp     cx, 11h
		jnz     heavy
		test    byte ptr ds:46FE10h, 1
		jnz     NEXT
		mov     ecx, esi
		sub     ecx, 36h
		movzx   dx, byte ptr [ecx+16h]
		jmp     NEXT
	heavy:
		test    byte ptr ds:46FE10h, 1
		jnz     NEXT
		mov     ecx, esi
		sub     ecx, 36h
		test    byte ptr ds:46FE26h, 1
		jnz     skip
		sub     ecx, 36h
	skip:
		movzx   dx, byte ptr [ecx+16h]
	NEXT:
		mov     ecx, 45B612h
		jmp     ecx
	}
}